function [PC,PNu,PNs] = PNweight(phi, parmU,  talent, parmtt ,index )
%Pareto Negishi weight of  consumption,  

Theta = talent(:,1);
PI = talent(:,2);
T = length(index); 
pu = parmtt(:,:,1);
ps = parmtt(:,:,2) ;

% Compute each worker's productivity when choosing task s or u
zs = lprod(Theta,ps);
zu =  lprod(Theta,pu);

gamma_c = parmU(1);
gamma_n = parmU(2);
phi_inv = repmat(phi.^(-1),1, T);

C_sum = sum( phi_inv.^(-1./gamma_c) .*PI ,1);
PC = phi_inv.^(-1/gamma_c)./C_sum;  % consumption ratio


NPI = length(PI);
Sindx = zeros(NPI,T);
ssind  = repmat((1:NPI)',1,T) ;
indexx = repmat(  index, NPI, 1) ;
Sindx(indexx <= ssind) =1;
Uindx = 1-Sindx;
PIS = repmat(PI,1,T).*Sindx ;
PIU = repmat(PI,1,T).*Uindx;


phiqs = max(zs.*phi_inv, eps) ; 
phiqu =max(zu.*phi_inv, eps);
Ns_sum = sum(   (phiqs).^(-1/gamma_n).*zs.*PIS,  1);
Nu_sum = sum(  (phiqu ).^(-1/gamma_n).*zu.*PIU, 1);

PNs =   (phiqs).^(-1/gamma_n).*Sindx./Ns_sum ;
PNu =  (phiqu).^(-1/gamma_n).*Uindx./Nu_sum;


end
