function [ff, trd_new,IC, alc] = Trans_fb_tt( x ,parmf, parmU, parmP , iniK, ...
                                             talent, parmtt, qt, trd )
% Transitional dynamic under first best case

global  delta_s  delta_e   beta


psi  = parmP.weight;   %  Pareto weight length(psi) = length(PI); 
Gr   = parmP.G ; 

Theta = talent(:,1);  PI = talent(:,2);
M = size(talent,1);

pu = parmtt(:,:,1);   
ps = parmtt(:,:,2);

zu  = lprod(Theta,pu);  %    NxT matrix
zs   = lprod(Theta,ps);   %   NxT matrix
 

T = size(qt,1);   % T must larger than 1
XX =  reshape(x(1:5*T), T,5);
Ksp =  XX(:,1); Lu = XX(:,2);
Kep = XX(:,3); Ls =XX(:,4);
C = XX(:,5);   

cdelta = Theta(2) - Theta(1);
index =  floor(     (trd - Theta(1)  )/cdelta    ) +2 ;


Ks0 = iniK(1); Ke0 = iniK(2);
Ks = [Ks0;Ksp(1:end-1)];
Ke = [Ke0;Kep(1:end-1)];


% consumption share
[PC,PNu,PNs] = PNweight(psi, parmU,  talent, parmtt ,index' ) ;
% % dimension of  PC, PNu, PNs should be equal to  NPI x T
[Sindx, Uindx, PIS, PIU] = indf(index', PI);
c = PC.*repmat(C',M,1);   % MxT matrix
ZPI_U =  repmat(sum(PIU.*zu,1),M,1).*Uindx; % 
ZPI_S =  repmat(sum(PIS.*zs ,1), M, 1).*Sindx;
ZLS = repmat(Ls', M,1).*Sindx;
ZLU=  repmat(Lu', M,1).*Uindx;
n  = 1-(PNu+PNs).*(  ZPI_U+ZPI_S  -  ZLS-ZLU );  % M x T matrix
 
 [~,uc,vn] = util_mat(c,n,parmU);
 
vnu = vn.*Uindx;  vns =vn.*Sindx;
ucu = uc.*Uindx;  ucs = uc.*Sindx;
  
u =[Ks, Lu, Ke, Ls];
[Y, rs, re, ws,wu] = korv1(u, parmf) ;
WS = repmat(ws, 1,M)';
WU = repmat(wu,1,M)';


Gamma =  mean(psi.*uc,1)';

gamma_c = parmU(1); gamma_n = parmU(2);
PHI_C  =  sum(  PI.*  psi.^(1/gamma_c) ).^gamma_c;
qpsis =  min(psi./zs, 1/eps) ; qpsiu = min( psi./zu, 1/eps);
qpis  = PI.*zs; qpiu = PI.*zu;
PHI_Ls =   (sum(qpis.* qpsis.^(1/gamma_n).*Sindx).^(gamma_n))';
PHI_Lu =  (sum(qpiu.* qpsiu.^(1/gamma_n).*Uindx).^(gamma_n))';
PIZS = sum(PIS.*zs)'; 
PIZU = sum(PIU.*zu)';
[~,UC,VLs] = util1([C,Ls],parmU, PIZS);
[~,~,VLu] = util1([C,Lu], parmU, PIZU);
Gamma = PHI_C* UC;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Derivative of  first best
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Intertemporal conditions
EuqKs =  Gamma.*(rs + 1-delta_s);
fks = - Gamma  + beta*fop(EuqKs) ;

EuqKe =  Gamma.*(re + (1-delta_e)./qt);
fke = Gamma./qt  - beta.*fop(EuqKe) ;

% Intratemporal conditions 
fns = sum(psi.*vn.*Sindx +  WS.*zs.* Gamma'.*Sindx)';
fns1 =  PHI_Ls.*VLs + Gamma.*ws ;

fnu = sum(psi.*vn.*Uindx +  WU.*zu.*Gamma'.*Uindx)';
fnu1 = PHI_Lu.*VLu + Gamma.*wu;
% Resource constraint
frc = (1-Gr)*Y   + (1-delta_e)*Ke./qt  + (1-delta_s).*Ks ...
       - C  -Kep./qt - Ksp  ;
   




ff =[fks; fke; fns; fnu; frc];


% IC constraint  check, find the lowest binding type 
ewage = zs.*WS.*Sindx + zu.*WU.*Uindx;  % effective wage
ewage_pre =  [ewage(1,:);   ewage(1:end-1,:) ];
xi_t =ewage./ewage_pre;
c = PC.*repmat(C',M,1);   % MxT matrix

% recover each labor supply
ZPI_U =  repmat(sum(PIU.*zu,1),M,1).*Uindx;  
ZPI_S =  repmat(sum(PIS.*zs ,1), M, 1).*Sindx;
ZLS = repmat(Ls', M,1).*Sindx;
ZLU=  repmat(Lu', M,1).*Uindx;
n  = 1-(PNu+PNs).*(  ZPI_U+ZPI_S  -  ZLS-ZLU );    % M x T matrix
c_true = c; n_true = n;
%[c(2:end, :);c(end,:)];  n_true = [n(2:end,:);n(end,:)];


 
c_mic = [c(1,:); c(1:end-1,:)] ;  
n_mic = [n(1,:);n(1:end-1,:)]./xi_t;


V_true = inf_sum(util_mat(c_true,n_true,parmU)',beta);
V_mic = inf_sum(util_mat(c_mic,n_mic,parmU)',beta);
IC.diff = (V_true -V_mic)' ;
inds_max = min(find(IC.diff<0));  % mimum index choosing skilled task
id2 = t2ind(trd,Theta);
IC.indu = min(id2) -1 ;



FPI = cumsum(PI);
Sratio1 = 1 - FPI(index-1);                      
NS = sum(PIS.*n)';  NU = sum(PIU.*n)';
ZS = (Ls./NS);  ZU = (Lu./NU);
sp_model= ZS.*ws./(ZU.*wu) ;
alc.Ksp = Ksp;
alc.Kep = Kep;
alc.C = C;
alc.n = n;
alc.sp =  sp_model;
alc.SU = Sratio1;

% Social welfare
LFU = inf_sum(util_mat(c,n,parmU)' ,beta )  ;
alc.SW =sum(PI.*LFU'.*psi);



%%%% threshold check;
 gama_s  = ps(:,1);   psi_s  = ps(:,2);
 gama_u =  pu(:,1);  psi_u  = pu(:,2); 
 Delta = 1e-4;
 
 
trd_new = min( max((log(wu./ws + Delta)  +  psi_u - psi_s )./(gama_s - gama_u), Theta(1)) , Theta(end));  
llk = t2ind(trd_new, Theta); 
 
%  for ii = 1:T-1
%       if trd_new(ii) < trd_new(ii+1)
%           trd_new(ii+1) = trd_new(ii);
%       end
%  end
%trd_new = max(trd_new,  Theta(inds_max)+eps);
%  cdelta = Theta(2) - Theta(1);
% index_new  =   min( max(  ceil( (theta_new - Theta(1))/cdelta )+1 ,1), M);   
 
end