function I = intbc0(ct,nt,wt,rt, zt, Govp )
%intbc : Intertemporal bueget constraint of skilled and unskilled labor 
% We begin the tau_k from period 1 (first period is period 0)
% Ct refers to representative labor's consumption


% All variables are matrix;
% ct: NxT; nt: NxT
global delta_s
% Rt : return of capital structure
N = size(ct,1);
tk=Govp(:,1);
tn =Govp(:,2);  tn = repmat(tn',N,1);
Tr =Govp(:,3);  Tr = repmat(Tr',N,1);



% Intertemporal price between different period
RR  =  1+ (1-tk).*(rt  - delta_s);
Rt =1./[1 ; RR(1:end-1) ];
P0t = repmat(facprod(Rt)', N,1) ;




% Compute transitional term
At= ct-(1-tn).*wt.*zt.*nt -Tr ;

Trbudget = sum(P0t.*At,2);


% Steady state
X0 = P0t(end)*At(:,end)*Rt(end);  % The first term of end steady state
cr = Rt(end);
SS = X0/(1-cr);

I = Trbudget + SS;

end