function [ff, trd_new, alc] = ttce_trans(XX, parmf,parmU,parmT, talent, parmtt, ...
                                       qt ,K0, trd)
% transitional dynamics  of  CE assignment  model  (2020.07.24)
% talent to task model  of  competitive equilibrium
% dfA : distribution of asset holding
% ParmT : labor tax and capital tax
global delta_s delta_e beta 

alpha = parmf(1);
tks =parmT(:,1); tke = parmT(:,2);
tn =parmT(:,3);   G=parmT(:,4);

Theta = talent(:,1);  PI = talent(:,2);
cdelta =Theta(2) - Theta(1);  % difference between two type
% 3 dimension  array
pu = parmtt(:,:,1);   
ps = parmtt(:,:,2);
zu  = lprod(Theta,pu);  %    NxT matrix
zs   = lprod(Theta,ps);   %   NxT matrix

T = length(qt);
typeN = size(talent,1);
phi = XX(end-typeN+1:end); % length of phi should be equal to length(Theta);
%nx = length(XX(end-9:end));
x = reshape(XX(1:5*T),  T, 5  );
Ks_ld =x(:,1);
zNu =x(:,2); % aggregate labor supply of unskilled labor
Ke_ld  =x(:,3);
zNs =x(:,4); % aggregate "effective" labor supply of skilled labor
C = x(:,5) ; % Aggregate consumption
index =    floor((trd - Theta(1))/cdelta)+2   ;  % transform threshold to index
 
dfA  = phi./sum(PI.*phi);
Ks0 = K0(1); Ke0 = K0(2);
Ks =[Ks0 ; Ks_ld(1:end-1)] ; Ke = [Ke0 ; Ke_ld(1:end-1)];
ks0 = dfA*Ks0;  ke0 =dfA*Ke0;

[Y, rs, re, ws, wu] = korv1([Ks, zNu, Ke, zNs], parmf);
% index is an T x 1  array;


 [PC,PNu,PNs] = PNweight(phi, parmU,  talent, parmtt ,index' ) ;  % data
 % dimension of  PC, PNu, PNs should be equal to  NPI x T
[Sindx, Uindx, PIS, PIU] = indf(index', PI);
 
 

c = PC.*repmat(C',typeN,1);

ZPI_U =  repmat(sum(PIU.*zu,1),typeN,1).*Uindx; % 
ZPI_S =  repmat(sum(PIS.*zs ,1), typeN, 1).*Sindx;

ZNS = repmat(zNs', typeN,1).*Sindx;
ZNU=  repmat(zNu', typeN,1).*Uindx;
n  = 1-(PNu+PNs).*(  ZPI_U+ZPI_S  -       ZNS-ZNU     ); %?


[~,uc,vn] = util_mat(c,n,parmU);
qt_ld = fop(qt);
uc_ld = fop(uc')';



 
%  Resource constraint
 f1= (1-G).*Y + (1-delta_s)*Ks + (1./qt).*(1-delta_e).*Ke -...
     (C  + (1./qt).*Ke_ld + Ks_ld) ;
 

% Euler equation
MRS = mean(uc./(beta.*uc_ld),1)';
tks_ld = fop(tks);  tke_ld = fop(tke);
rs_ld = fop(rs);  re_ld = fop(re);
% % Nonlinear equation systems
 
 if alpha ==0
 f2 = Ks; 
 else
  f2 =  MRS - (1+ (1-tks_ld).*(rs_ld-delta_s));
 end

 f3 = MRS./qt -  ...
         (1./qt_ld + (1-tke_ld).*(re_ld - delta_e./qt_ld)  ) ;

 
% Intratemporal condition:
[dimz,~,~] = size(parmtt);  % parmtt  is an  T x 2 x 2 matrix 
if  dimz ==1
    Z = repmat( zu, 1,T).*Uindx +repmat(zs,1,T).*Sindx;
else
    Z = zu.*Uindx + zs.*Sindx;
end
W = repmat(wu',typeN,1).*Uindx + repmat(ws',typeN,1).*Sindx;
tauL =  repmat(tn',typeN,1);
f40 =  (vn + (1-tauL).*Z.*W.*uc);  
f4s = sum(f40.*PIS,1)';
f4u = sum(f40.*PIU,1)';
f4 = [f4s;f4u];
 

% budget constraint 
Trt = tn.*(ws.*zNs+wu.*zNu) + ...
    tke.*(re  - delta_e./qt).*Ke + ...
    tks.*(rs - delta_s).*Ks- ...
    G.*Y;
 
Govp = [ tks, tn,Trt];
Ibc = intbc0(c,n,W,rs,Z, Govp);
 
A0 = (1/qt(1)  +(1-tke(1))*(re(1) - delta_e/qt(1) )  ) *ke0 +...
          (1+  (1-tks(1))*(rs(1) - delta_s))*ks0;
f5 = Ibc - A0;      


% We put some penalty function in final 30 period
   spn =25;
   bmzKs  = mean(Ks(T-spn-1:T));
   bmzNu   = mean(zNu(T-spn-1:T));
   bmKeld = mean( Ke_ld(T-spn-1:T));
   bmzNs   = mean(zNs(T-spn-1:T));
   bmC    =  mean(C(T-spn-1:T));
  
   fKs = 100 * (Ks(T-spn+1:T) - bmzKs);
   fNu =100*  (zNu(T-spn+1:T)-bmzNu);
   fKe = 100 *(Ke_ld(T-spn+1:T) -bmKeld) ;
   fNs = 100* (zNs(T-spn+1:T) -bmzNs) ;
   fC  =  100* (C(T-spn+1:T) -bmC) ;

   
 fphi =  sum(PI.*phi)-1;  

ff =[f1;f2;f3;f4;f5;fKs;fNu;fKe;fNs;fC; fphi];



% Find out new threshold
gama_u= pu(:,1); psi_u =  pu(:,2);
gama_s =  ps(:,1) ;psi_s =  ps(:,2);
trd_new = min( max( (log(wu./ws) +psi_u - psi_s)./(gama_s - gama_u+eps),...
                           Theta(1)+eps) , Theta(end)-eps) ;
index_new = floor((trd - Theta(1))/cdelta) +2 ; 
FPI = cumsum(PI);

Sratio = 1 - FPI(index_new-1);             
NS = sum(PIS.*n)';  NU = sum(PIU.*n)';
ZS = (zNs./NS);  ZU = (zNu./NU);
sp_model= ZS.*ws./(ZU.*wu) ;

alc.sp = sp_model;
alc.sr = Sratio;
alc.Y = Y;
alc.C = C;
alc.Kep = Ke_ld;
alc.Ls = zNs;
alc.Lu = zNu;
alc.Ns = sum(n.*PIS,1)';
alc.Nu = sum(n.*PIU,1)';
alc.c = c;
alc.n = n;
alc.ZS=ZS;
psi = ones(typeN,1);
LFU = inf_sum(util_mat(c,n,parmU)' ,beta ) ;
alc.SW =sum(PI.*LFU'.*psi);
alc.cweight = PC(:,1);
 
end