function  [ff, trd,alc]  = ttce_transc(XX, parmf,parmU,parmT, talent, parmtt, ...
                                        moment , qt, iniK0)
% transitional dynamics  of  talent to task model
% talent to task model  of  competitive equilibrium
% dfA : distribution of asset holding
% ParmT : labor tax and capital tax
% sp: skill permium matched;
% index:  skill labor ratio;
global delta_s delta_e beta 


Theta = talent(:,1);  PI = talent(:,2);
M = size(talent,1);
T = length(qt);


% last  typeN variables
 
phi = XX(end-M+1: end); % length of phi should be equal to length(Theta);
x = reshape(XX(1:5*T),  T, 5);
Ks_ld =x(:,1); zNu =x(:,2); % aggregate labor supply of unskilled labor
Ke_ld  =x(:,3);  zNs =x(:,4); % aggregate "effective" labor supply of skilled labor
C = x(:,5) ; % Aggregate consumption

zparm = XX(5*T+1 : 7*T);
ps = reshape(zparm, length(zparm)/2,2);
gama_s = ps(:,1); psi_s   = ps(:,2);
dFA  = phi./sum(PI.*phi);

alpha = parmf(1);
tks =parmT(:,1); tke = parmT(:,2);
tn =parmT(:,3);   G=parmT(:,4);


% Productivity
pu = parmtt(:,:,1);   
ps = [gama_s,psi_s];
zu  = lprod(Theta,pu);  %    NxT matrix
zs   = lprod(Theta,ps);   %   NxT matrix



Ks0 =iniK0(1); Ke0 = iniK0(2);
Ks =[Ks0 ; Ks_ld(1:end-1)] ; Ke = [Ke0 ; Ke_ld(1:end-1)];
ks0 = dFA*Ks0;  ke0 =dFA*Ke0;

[Y, rs, re, ws, wu] = korv1([Ks, zNu, Ke, zNs], parmf);

index = moment(:,1)';
sp = moment(:,2);
parmttz = cat(3,pu,ps);

% Convert  aggregate consumption and Pareto Negishi weight to  each
% worker's  allocation
 [PC,PNu,PNs] = PNweight(phi, parmU,  talent, parmttz ,index ) ;
[Sindx, Uindx, PIS, PIU] = indf(index, PI);
 
 
ZPI_U =  repmat(sum(PIU.*zu,1),M,1).*Uindx;  
ZPI_S =  repmat(sum(PIS.*zs ,1), M, 1).*Sindx;
ZNS = repmat(zNs', M,1).*Sindx;
ZNU=  repmat(zNu', M,1).*Uindx;
% Each agent's  consumption and labor supply
c = PC.*repmat(C',M,1);
n  = 1-(PNu+PNs).*(  ZPI_U+ZPI_S  -  ZNS-ZNU     );  


[~,uc,vn] = util_mat(c,n,parmU);
qt_ld = fop(qt);
uc_ld = fop(uc')';


%  Resource constraint
 f1= (1-G).*Y + (1-delta_s)*Ks + (1./qt).*(1-delta_e).*Ke -...
     (C  + (1./qt).*Ke_ld + Ks_ld) ;
 

% Euler equation
MRS = mean(uc./(beta.*uc_ld),1)';
tks_ld = fop(tks);  tke_ld = fop(tke);
rs_ld = fop(rs);  re_ld = fop(re);
% % Nonlinear equation systems
% 
 if alpha ==0
 f2 = Ks; 
 else
  f2 =  MRS - (1+ (1-tks_ld).*(rs_ld-delta_s));
 end

 f3 = MRS./qt -  ...
         (1./qt_ld + (1-tke_ld).*(re_ld - delta_e./qt_ld)  ) ;

 
% Intratemporal condition:
[dimz,~,~] = size(parmtt);  % parmtt  is an  T x 2 x 2 matrix 
if  dimz ==1
    Z = repmat( zu, 1,T).*Uindx +repmat(zs,1,T).*Sindx;
else
    Z = zu.*Uindx + zs.*Sindx;
end


W = repmat(wu',M,1).*Uindx + repmat(ws',M,1).*Sindx;
tauL =  repmat(tn',M,1);
f40 =  (vn + (1-tauL).*Z.*W.*uc);  
f4s = sum(f40.*PIS,1)';
f4u = sum(f40.*PIU,1)';
f4 = [f4s;f4u];

 
% budget constraint : compute  lump-sum transfer
Trt = tn.*(ws.*zNs+wu.*zNu) + ...
    tke.*(re  - delta_e./qt).*Ke + ...
    tks.*(rs - delta_s).*Ks- ...
    G.*Y;
 
Govp = [ tks, tn,Trt];
Ibc = intbc0(c,n,W,rs,Z, Govp);
 
A0 = (1/qt(1)  +(1-tke(1))*(re(1) - delta_e/qt(1) )  ) *ke0 +...
          (1+  (1-tks(1))*(rs(1) - delta_s))*ks0;
f5 = Ibc - A0;      


% We put some penalty functions in final 30 period
   spn =50;
   
   bmzKs  = mean(Ks(T-spn-1:T));
   bmzNu   = mean(zNu(T-spn-1:T));
   bmKeld = mean( Ke_ld(T-spn-1:T));
   bmzNs   = mean(zNs(T-spn-1:T));
   bmC    =  mean(C(T-spn-1:T));
  
   fKs = 100 * (Ks(T-spn+1:T) - bmzKs);
   fNu =100*  (zNu(T-spn+1:T)-bmzNu);
   fKe = 100 *(Ke_ld(T-spn+1:T) -bmKeld) ;
   fNs = 100* (zNs(T-spn+1:T) -bmzNs) ;
   fC  =  100* (C(T-spn+1:T) -bmC) ;
   
   
 
NS = sum(PIS.*n)';  NU = sum(PIU.*n)';
ZS = (zNs./NS);  ZU = (zNu./NU);
sp_model= ZS.*ws./(ZU.*wu) ;
mom1 = (log(sp_model) - log(sp))*0.8;


%  Update the threshold given the allocation
gama_u =pu(:,2);   psi_u=pu(:,1);

trd_new =  (log(wu./ws) + psi_u - psi_s)./(gama_s - gama_u ) ;
theta_old = Theta(index') -1e-8 ;
mom2 = (trd_new- theta_old)*5;                    
trd = theta_old;

 
fphi = sum(phi.*PI)-1;


ff =[f1;f2*5;f3*5;f4;f5;fKs;fNu;fKe;fNs;fC;mom1;mom2; fphi];
ZS = zNs./sum(PIS.*n)';
FPI = cumsum(PI);
sr  =  1-FPI(index-1);

alc.ZS = ZS;
alc.sp = sp_model;
alc.sr = sr;
alc.Ke = Ke;
alc.Ks  = Ks;
alc.re = re;
alc.rs = rs;

end