clc
clear
%%
% Saving directory  
fname =cd;  % office
load Mirrlees_benchmark.mat
 
 Xaxis = (1:T)' + 1962;   
idx = (1:59)';
 

 % Recover tax rates and skill premium:
 taxke = zeros(T,sgn); taxks = zeros(T,sgn); taxLs = zeros(T,sgn);
 wp_trans = zeros(T,sgn);  Ke_trans = zeros(T,sgn); 
 Ns_trans= zeros(T,sgn) ;   Nu_trans= zeros(T,sgn);
 taxLu =taxLs;

% test the result
  
lgds = { ['\sigma =  ' , num2str(sigmas(1))] ,...
               ['\sigma =  ' , num2str(sigmas(2))],...
               ['\sigma =  ' , num2str(sigmas(3))],...
               ['\sigma =  ' , num2str(sigmas(4))],...
               ['\sigma =  ' , num2str(sigmas(6))]};

for ji =1:sgn
 taxke(:,ji) =  [tau_k; taxm(ji).ke(1:end-1)] ;       
 taxLs(:,ji) = taxm(ji).s;  
 taxLu(:,ji)= taxm(ji).u;
 wp_trans(:,ji) = pricem(ji).wp;
 Ns_trans(:,ji) = alcm(ji).Ns;
 Nu_trans(:,ji)=alcm(ji).Nu ;   % aggregate labor supply of unskilled labor
 Ke_trans(:,ji) =alcm(ji).Ke ;
end

 
%% 
taxarray =[1 2 3 4 6]; 


% Unskilled tax
fgmtl =figure;  % labor tax
fig1 =subplot(2,4,[3 4]);
fglu = plot(Xaxis(idx), taxLu(idx,taxarray), 'LineWidth',0.8);
fglu(1).LineStyle ='--' ; fglu(2).LineStyle ='-.';  fglu(3).LineStyle ='--';
fglu(3).Marker ='d';   fglu(3).MarkerSize =3;
fglu(5).Marker = '+';  fglu(4).Marker = '>';  fglu(4).MarkerSize =3;
 ylim([0,1]);
set(gca,'YGrid','on')
box off
xlabel('Year')
ylim([0.15,0.35])
xlim([1960 2020])
title('Labor tax rates on unskilled')

% Skilled tax rates
fig2 =subplot(2,4, [7 8]);
fgls = plot(Xaxis(idx), taxLs(idx,taxarray), 'LineWidth', 0.8);
fgls(1).LineStyle ='--' ; fgls(2).LineStyle ='-.';  fgls(3).LineStyle ='--';
fgls(3).Marker ='d';   fgls(3).MarkerSize =3;
fgls(5).Marker = '+';  fgls(4).Marker = '>';  fgls(4).MarkerSize =3;
title('Labor tax rates on skilled')
xlabel('Year')
box off
ylim([-0.2 0.05])
xlim([1960 2020])
set(gca,'YGrid','on')


fgmk = subplot(2,4, [1 2 5 6]);
fgk = plot(Xaxis(idx),taxke(idx,taxarray), 'LineWidth',0.8);
 fgk(1).LineStyle ='--' ; fgk(2).LineStyle ='-.';  fgk(3).LineStyle ='--';
 fgk(3).Marker ='d';   fgk(3).MarkerSize =3;
 fgk(5).Marker = '+';  fgk(4).Marker = '>';  fgk(4).MarkerSize =3;
title( 'Capital tax rates on equipment' )
xlabel('Year')
box off
set(gca,'YGrid','on')
lgg = legend(lgds, 'Location', 'Northeast');
set(lgg, 'Box','off')
xlim([1960 2020])
fgmtl.Position = [288 134 560*2  420];

saveas(fgmtl, fullfile(fname, 'Mirrlees_benchmark3'), 'epsc');


%% Pareto weight case


taxkep = zeros(T,pwn);
taxsp = zeros(T,pwn);  taxup = zeros(T,pwn);
wp_transp = zeros(T,pwn);  Ke_transp = zeros(T,pwn); 
Ns_transp= zeros(T,pwn) ;   Nu_transp= zeros(T,pwn);

% Collect allocation under 
for ji =1:pwn
 taxkep(:,ji) =  [tau_k; taxmp(ji).ke(1:end-1)] ;       
 taxsp(:,ji) = taxmp(ji).s;  
 taxup(:,ji) = taxmp(ji).u;  
 wp_transp(:,ji) = pricemp(ji).wp;
 Ns_transp(:,ji) = alcmp(ji).Ns;
 Nu_transp(:,ji)=alcmp(ji).Nu ;   % aggregate labor supply of unskilled labor
 Ke_transp(:,ji) =alcmp(ji).Ke ;
end

RQp = Nu_transp./Ns_transp;
KSp = Ke_transp./Ns_transp;
  

lgdp = {  ['\psi_u/\psi_s =  ' , num2str(pweight(1))],...
               ['\psi_u/\psi_s =  ' , num2str(pweight(2))],...
               ['\psi_u/\psi_s =  ' , num2str(pweight(3))]};
           
 
np = 2020-1963+1;          
Xaxisp = Xaxis(1:np)  ;
fgmtp = figure;
        % capital tax on equipment
        ba0 = subplot(2,4, [1 2   5  6]);
        ab = plot(Xaxisp,taxkep(1:np,:),'LineWidth',1.1);
        ab(2).LineStyle = ':' ;
        ab(3).LineStyle = '--';
        lgsp= legend( lgdp, 'Location','Northeast');
        set(lgsp,'Box','off')
        title( 'Capital tax rates on equipment')
        ylim([0  1.2])
        box off
        set(gca,'YTick',(0:0.1:1.2)')
        set(gca, 'YGrid','on')
        
        % skilled labor tax rates
        ba = subplot(2,4,[7 8]);
        bb=plot(Xaxisp,taxsp(1:np,:),'LineWidth',1.1);
        bb(2).LineStyle = ':' ;
        bb(3).LineStyle = '--';
        title('Labor tax rates on skilled')
        ylim([-0.6  0.1])
        box off
        set(gca,'YTick',(-0.6:0.2:0.1)')
        set(gca, 'YGrid','on')
         
        % unskilled labor tax rates
        ca = subplot(2,4,[3  4]);
        cb=plot(Xaxisp,taxup(1:np,:),'LineWidth',1.1);
        cb(2).LineStyle = ':' ;
        cb(3).LineStyle = '--';
        title('Labor tax rates on unskilled')
        ylim([0 0.7])
        set(gca,'YTick',(0.1:0.2:0.7)')
        set(gca, 'YGrid','on')
        box off
        fgmtp.Position =[47   205   560*2   420];

saveas(fgmtp, fullfile(fname, 'Mirrlees_benchmark1' ), 'epsc')       

 
 
%% % Final skill premium and  KS, RQ component

fgwpp = figure;
        wppa0 = subplot(2,4, [1 2   5  6]);
        wppab = plot(Xaxisp,wp_transp(1:np,:),'LineWidth',1.1);
        wppab(2).LineStyle = ':' ;
        wppab(3).LineStyle = '--';
        lgsp2= legend( lgdp, 'Location','Northwest');
        set(lgsp2,'Box','off')
        title( 'Skill premium')
        box off
        set(gca, 'YGrid','on')
        
       % Capital skill complementary effect
       wppca = subplot(2,4,[3  4]);
        wppcb=plot(Xaxisp,KSp(1:np,:),'LineWidth',1.1);
        wppcb(2).LineStyle = ':' ;
        wppcb(3).LineStyle = '--';
        title('K_e/N_s')
        box off
        set(gca, 'YGrid','on')
       
        wppa = subplot(2,4,[7 8]);
        wppb=plot(Xaxisp,RQp(1:np,:),'LineWidth',1.1);
        wppb(2).LineStyle = ':' ;
        wppb(3).LineStyle = '--';
        title('N_u/N_s')
        box off
        set(gca, 'YGrid','on')
        ylim([0.5 1])
        fgwpp.Position =[47   205   560*2   420];
           
saveas(fgwpp, fullfile(fname, 'Mirrlees_benchmark4'), 'epsc')       

%%

lgdr ={'\tau_{ke} (left axis)', '\Delta q/q (right axis)'} ;
   idx = 1962 +(1:58); %1963 - 2020
   dq = diff(log(qt));  dq = dq(idx-1962);
   taukk = taxke(2:end,4); taukk = taukk(idx-1962);
   
   
%  Trend and fluctuation between capital tax and growth rate of qt
   cqt = figure;
  figm4a = subplot(1,2,1);
  [cqt1, cqt2, cqt3] = plotyy(idx,taukk, idx, dq); 
  cqt3.LineStyle ='-.';
  cqt3.LineWidth = 1.1;
  cqt2.LineWidth =1.1;
  lgdrr = legend(lgdr,'Location','NorthEast');
  set(lgdrr,'Box','off')
  set(gca,'YGrid','on')
  set(gca,'YTick',(0.1:0.1:0.7)')
  ylim([0 0.7])
  box off
  
 figm4b =subplot(1,2,2);
   [cqt4, cqt5, cqt6] = plotyy(idx,hpfilter(taukk,100), idx, hpfilter(dq,100));
   cqt4(1).YLim = [0.05 0.25];
   cqt4(2).YLim = [0.02 0.1];
   cqt6.LineStyle ='-.';
    cqt6.LineWidth = 1.1;
    cqt5.LineWidth =1.1;
    cqt6.LineWidth = 1.1;
    cqt5.LineWidth =1.1;
    set(lgdrr,'Box','off')
    set(gca,'YGrid','on')  
    cqt.Position = [188 142 560*2 420] ;
    set(gca,'YTick',(0:0.05:0.25)')
 box off
saveas(cqt, fullfile(fname,  'Mirrlees_benchmark2'), 'epsc');

 
 