clc
clear
%% 
fname =cd;  


% Content:
load  Ramsey_benchmark.mat
 
 
Xaxis = (1:58)' + 1962;   
lgx = length(Xaxis);

% Recover tax rates and skill premium:
taxke = zeros(T,sgn); taxks = zeros(T,sgn); taxLs = zeros(T,sgn);
wp_trans = zeros(T,sgn);  Ke_trans = zeros(T,sgn); 
Ns_trans= zeros(T,sgn) ;   Nu_trans= zeros(T,sgn);

% test the result
ji =1;

lgds = { ['\sigma =  ' , num2str(sigmas(1))] ,...
               ['\sigma =  ' , num2str(sigmas(2))],...
               ['\sigma =  ' , num2str(sigmas(3))],...
               ['\sigma =  ' , num2str(sigmas(4))],...
               ['\sigma =  ' , num2str(sigmas(5))],...
               ['\sigma =  ' , num2str(sigmas(6))]};

for ji =1:sgn
 taxke(:,ji) =  [tk0; rtax(ji).ke(1:end-1)] ;       
 taxLs(:,ji) = rtax(ji).s;  
wp_trans(:,ji) = rprice(ji).wp;
 Ns_trans(:,ji) = ralc(ji).Ns;
 Nu_trans(:,ji)=ralc(ji).Nu ;   % aggregate labor supply of unskilled labor
 Ke_trans(:,ji) =ralc(ji).Ke ;
end

idxs =[1;2;3;4;6];


frtl = figure;
subplot(1,2,2)
 fg2 = plot(Xaxis,taxLs(1:lgx,idxs), 'LineWidth',1.1);
   fg2(1).LineStyle ='--' ; fg2(2).LineStyle ='-.';  fg2(3).LineStyle ='--';
   fg2(3).Marker ='d';   fg2(3).MarkerSize =3;
  fg2(5).LineStyle ='--';
   fg2(5).Marker = '+'; 
  fg2(4).Marker = '>';  fg2(4).MarkerSize =3;
   set(gca,'YGrid','on')
%   ylabel('tax_L')
   xlabel('Year')
   ylim([-0.4, 0.4])
   title('Labor tax rates')
   frtl1 = 'tL_Ramsey_trans_qt'; 
box off
 
subplot(1,2,1)
fg2 = plot(Xaxis ,taxke(1:lgx,idxs) , 'LineWidth',1.1);
   fg2(1).LineStyle ='--' ; fg2(2).LineStyle ='-.';  fg2(3).LineStyle ='--';
   fg2(3).Marker ='d';   fg2(3).MarkerSize =3;
  fg2(5).LineStyle ='--';
  fg2(5).Marker = '+'; 
   fg2(4).Marker = '>';  fg2(4).MarkerSize =3;
   title('Capital tax rates on equipment')
 xlabel('Year')
  set(gca,'YGrid','on')
  ylim([0 1 ])
  lgg = legend(lgds(idxs), 'Location', 'Northeast','Box','off');
  set(lgg,'Box','off')
box off
frtl.Position =  [88 88 560*2 420];
saveas(frtl, fullfile(fname, 'Ramsey_benchmark3'), 'epsc'); 
 


%% Different  Pareto weight under different case

taxkep = zeros(T,pwn); taxksp = zeros(T,pwn); 
taxLsp = zeros(T,pwn);
wp_transp = zeros(T,pwn);  Ke_transp = zeros(T,pwn); 
Ns_transp= zeros(T,pwn) ;   Nu_transp= zeros(T,pwn);

for ji =1:pwn
 
 taxkep(:,ji) =  [tk0; rtaxp(ji).ke(1:end-1)] ;       
 taxLsp(:,ji) = rtaxp(ji).s;  
wp_transp(:,ji) = rpricep(ji).wp;
 Ns_transp(:,ji) = ralcp(ji).Ns;
 Nu_transp(:,ji)=ralcp(ji).Nu ;   % aggregate labor supply of unskilled labor
 Ke_transp(:,ji) =ralcp(ji).Ke ;
end
RQp = Nu_transp./Ns_transp;
KSp = Ke_transp./Ns_transp;


lgdp = {  ['\psi_u/\psi_s =' , num2str(pweight(1))],...
               ['\psi_u/\psi_s= ' , num2str(pweight(2))],...
               ['\psi_u/\psi_s= ' , num2str(pweight(3))]};
           
 np = 2020-1963+1;          
Xaxisp = Xaxis(1:np)  ;
fgrtp = figure;
ca = subplot(1,2,1);
        cb=plot(Xaxisp,taxkep(1:np,:),'LineWidth',0.9);
        cb(2).LineStyle = ':' ;
        cb(3).LineStyle = '-.';
        gg = legend(lgdp, 'Location','Northeast','Box','off');
        title('Capital tax rates on equipment')
        xlabel('Year')
        ylim([0.2  1.1])
        set(gca,'YTick',(0.2:0.2:1.2)')
        set(gca, 'YGrid','on')
        box off
        
        ca = subplot(1,2,2);
        bb=plot(Xaxisp,taxLsp(1:np,:),'LineWidth',0.9);
        bb(2).LineStyle = ':' ;
        bb(3).LineStyle = '-.';
        xlabel('Year')
        title('Labor tax rates')
        ylim([-0.1  1])
        set(gca,'YTick',(0:0.1:1)')
        set(gca, 'YGrid','on')
        fgrtp.Position =  [488 342 560*2  420]/1.2;
        box off
saveas(fgrtp, fullfile(fname, 'Ramsey_benchmark1'), 'epsc')   



%%

taukk = rtax(4).ke(1:58); % Benchmark Ramsey capital tax with sigma = 0.401
dq = diff(log(qt(1:59)));
dq2 = 1./(beta*qt(1:58)) -1./qt(2:59);
taull = rtax(4).s(1:58);
wpp = rprice(4).wp(1:58);

x = ...
[corrcoef(taukk, dq),...
corrcoef(taukk, wpp),...
corrcoef(taull, dq),...
corrcoef(taull, wpp),...
corrcoef(taukk,dq2)]';
  
 
lgdr ={'\tau_{ke} (left axis)', '\Delta q/q (right axis)'} ;
lgdr2 ={'filtered \tau_{ke} (left axis)', 'filtered \Delta q/q (right axis)'} ;
 idx = 1962 +(1:58);
 cqt = figure;
 subplot(1,2,1)
 [cqt1, cqt2, cqt3] = plotyy(idx,taukk, idx, dq);
 cqt3.LineStyle ='-.';
 cqt3.LineWidth = 1.1;
 cqt2.LineWidth =1.1;
 lgdrr = legend(lgdr,'Location','NorthEast');
 set(lgdrr,'Box','off')
 set(gca,'YGrid','on')
 box off
 subplot(1,2,2)
 [cqt4, cqt5, cqt6] = plotyy(idx,hpfilter(taukk,100), idx, hpfilter(dq,100));
 cqt6.LineStyle ='-.';
  cqt6.LineWidth = 1.1;
  cqt5.LineWidth =1.1;
  cqt6.LineWidth = 1.1;
  cqt5.LineWidth =1.1;
   lgdrr = legend(lgdr2,'Location','NorthWest');
    set(lgdrr,'Box','off')
   set(gca,'YGrid','on')
   cqt.Position = [188 142 560*2 420] ;
 box off
 saveas(cqt, fullfile(fname, 'Ramsey_benchmark2'), 'epsc'); 
 
 
 %%  Skill premium case
fgrpp = figure;
        wppa0 = subplot(2,4, [1 2   5  6]);
        wppab = plot(Xaxisp,wp_transp(1:np,:),'LineWidth',0.9);
        wppab(2).LineStyle = ':' ;
        wppab(3).LineStyle = '--';
        legend( lgdp, 'Location','Northwest','Box','off')
        title( 'Skill premium')
        box off
        set(gca, 'YGrid','on')
        
       wppca = subplot(2,4,[3  4]);
        wppcb=plot(Xaxisp,KSp(1:np,:),'LineWidth',0.9);
        wppcb(2).LineStyle = ':' ;
        wppcb(3).LineStyle = '--';
        title('K_e/N_s')
        box off
        set(gca, 'YGrid','on')
      
        wppa = subplot(2,4,[7 8]);
        wppb=plot(Xaxisp,RQp(1:np,:),'LineWidth',0.9);
        wppb(2).LineStyle = ':' ;
        wppb(3).LineStyle = '--';
        title('N_u/N_s')
        set(gca, 'YGrid','on')
        box off
        fgrpp.Position =[47   205   560*2   420]/1.5;
 saveas(fgrpp, fullfile(fname, 'Ramsey_benchmark4'), 'epsc');         
        
 %%
 
 
 
% Skill premium with different sigma
 
wpr = wp_trans;
frwp = figure; 
fg2 = plot(Xaxis,wpr(1:lgx,:), 'LineWidth',1.1);
 fg2(1).LineStyle ='--' ; fg2(2).LineStyle ='-.';  fg2(3).LineStyle ='--';
 fg2(3).Marker ='d';   fg2(3).MarkerSize =3;
 fg2(6).LineStyle =':';
 fg2(5).Marker = '+';  fg2(4).Marker = '>';  fg2(4).MarkerSize =3;
title(['Skill premium (Ramsey) '])
lgg = legend(lgds, 'Location', 'Northwest');
set(lgg,'Box','off')
ylabel('skill premium')
xlabel('Year')
set(gca,'YGrid','on')
 
%%
 
 
