% Create Figure 
clear
clc
%%
load('Data/data.mat')
%%
fname =[cd,'/fig'];
fred_q =qtq(:,1);
qyear = (1963:0.25:2020)';
nq =length(fred_q);

%% Investment specific shocks

f02= figure ;
plot(qyear(1:nq), fred_q,'LineWidth',1.3)
xlim([1963 2020])
xlabel('Year')
set(gca,'XTick',(1960:10:2010))
box off
set(gca,'YGrid','on')
f02.Position =[488 301 560 420];
saveas(f02, fullfile(fname, 'fred_qt'), 'epsc');


 

% %  Tax rate from McDaniels
 mcyr =(1963:2015)';
 f01 = figure ;
 plot(mcyr, tk_us_ext(mcyr-1962), mcyr,tn_us_ext(mcyr-1962),':','LineWidth',1.3)
 txt1 = '\leftarrow Labor Tax ';
 txt2 = '\leftarrow Capital Tax ';
 legend('Capital tax', 'Labor tax','Box','off')
 set(gca,'YGrid','on')
 xlim([1960 2020])
 xlabel('Year')
 ylim([0.05 0.43])
 box off
 f01.Position =[488 301 560 420];
 saveas(gca, fullfile(fname, 'tax_us'), 'epsc');
