%Create figures in extended model
clc;clear

%% Plot  CE /  Ramsey / Mirrlees tax rates
fname =cd;  % office
% Set saving Location and paths
index_I =(2:65)'; Year = 1962+index_I;
darkgreen = [0,153/255,76/255];
load('CEext.mat')
%addpath('Assignment_case','Figures')
[result,trd, alc_ce] = ttce_trans(xsol40,parmf,parmU,parmT0,talent,parmtz,qt,K00,threshold0);

taxL_ce = parmT0(index_I,3);
taxK_ce = parmT0(index_I,1);
sp_ce = log(alc_ce.sp(index_I));

%% Plot  calibration results;
%  Skill premium and skill labor ratio
index_d =(1:50)';
Year_data = 1963+index_d;
srdata = efu_data_ext(index_d);

figspsr = figure;
fig4a = plot(Year_data, alc_ce.sp(index_d), 'LineWidth',1.1);
hold on
fig4b = plot(Year_data,sp_data_ext(index_d),'o');
lgdce = {'Model', 'Data'};
lgd=legend(lgdce,'Location','NorthWest','Box','off');
box off
title('Skill premium')
set(gca,'YGrid','on')
figspsr.Position = [488 342 560 420];
saveas(figspsr, fullfile(fname, 'model_data_sr'), 'epsc');  

fig4c = figure;
fig4c1 = plot(Year_data, [alc_ce.sr(index_d),srdata], 'LineWidth',1.1);
lgd2 = legend(lgdce,'Location','NorthWest','Box','off');
 fig4c1(2).LineStyle ='-.' ;  
 box off
set(gca,'YGrid','on')
title('Skill worker ratio')
fig4c.Position = [488 342 560 420];
saveas(fig4c, fullfile(fname, 'model_data_sp'), 'epsc');  


% Productivity
index_d2 =(1:60)';
Year_data2 = 1963+index_d2;
ZS   =log(alc_ce.ZS(index_d2)/alc_ce.ZS(1));
figz = figure;
figza1 = plot(Year_data2, ZS, 'LineWidth',1);
xlim([Year_data(1), Year_data2(end)])
set(gca,'YGrid','on')
ylabel('log(zs)')
box off
saveas(figz, fullfile(fname, 'zs_ext'), 'epsc'); 


%% Collect  Ramsey tax 
load Ramsey_ext.mat
[xx,~,alcr, tax_r] =solve_Ramsy_tt(xrt2,parmf,parmU,parmp,parmtt,talent2, ...
                            iniK0, dfa1, qt ,trd_old);
trd_r= trd_old;
taxL_r = tax_r.L(index_I);
taxK_r = taxr.ke(index_I);
sp_ramsey = log(alcr.sp(index_I)) ;          

%%
load Mirrlees_ext.mat                        
[testtt, trd_new2,alcsb2,taxsb] =Trans_ICtt3(xtsolsb2,parmfs,parmU,parmP22,talent_new,parmtt2,K0, ...
                                 qtt, trd_sb2, Delta_IC4,ctind);        
taxK_m =taxsb.ke(index_I);
taxL_m = taxsb.L(index_I);
sp_m = log(alcsb2.sp(index_I));                                                         
                                                         
%% Taxes and Skill premium 
sp_lgd = {'U.S','Ramsey','Mirrlees'};
sp_ext =[sp_ce,sp_ramsey, sp_m];
taxL_ext = [taxL_ce, taxL_r,taxL_m];
taxK_ext = [taxK_ce, taxK_r, taxK_m];

fig_tax_ext = figure;
subplot(1,2,1)
fig_t1 = plot(Year, taxL_ext(:,:),'LineWidth',1.1);
fig_t1(1).LineStyle='-.';    fig_t1(1).Color =[0.9290, 0.6940, 0.1250];
fig_t1(2).LineStyle='-';    fig_t1(2).Color =[0 0.5 1];
fig_t1(3).LineStyle='--'; fig_t1(3).Color =[0 0.5 0];
title('Labor marginal tax rates')
lgdt = legend(sp_lgd, 'Location', 'Northwest');
lgdt.Box ='off';
box off
xlim([1960 2025])
ylim([0 0.7])
set(gca,'YGrid','on');
subplot(1,2,2)
fig_t2 = plot(Year, taxK_ext(:,:),'LineWidth',0.8);
fig_t2(1).LineStyle='-.'; fig_t2(1).Color =[0.9290, 0.6940, 0.1250];
fig_t2(2).LineStyle='-'; fig_t2(2).Color =[0 0.5 1];
fig_t2(3).LineStyle='--'; fig_t2(3).Color =[0 0.5 0];
title('Capital tax rates')
set(gca,'YGrid','on')
box off
xlim([1960 2025])
ylim([0,0.7])
fig_tax_ext.Position = [488 342 560*2 420];
saveas(fig_tax_ext, fullfile(fname, 'tax_ext' ), 'epsc');   
%%  Skill premium Compare:

fig_sp_ext = figure;
fig_sp = plot(Year, sp_ext(:,:),'LineWidth',1.1);
fig_sp(1).LineStyle='-.';   fig_sp(1).Color =[0.9290, 0.6940, 0.1250];
fig_sp(2).LineStyle='-';    fig_sp(2).Color =[0 0.5 1];
fig_sp(3).LineStyle='--';  fig_sp(3).Color =[0 0.5 0];
lgdsp = legend(sp_lgd, 'Location', 'Northwest');
lgdsp.Box ='off';
box off
xlim([1960 2025])
ylim([0.35 0.8])
set(gca,'YGrid','on');
saveas(fig_sp_ext, fullfile(fname, 'fig_sp_ext' ), 'epsc');  

%% Mirrlees nonlinear  labor tax
Mm = size(taxsb.n,1);
taxmn = [taxsb.n(1,:).*ones(M-Mm,TT);taxsb.n];       % M = 40  
T1 = 1964; T2 = 1988;   T3 = 2012; 
mt_lgd = {'1964','1988','2012'};
mtax =[ taxmn(:,T1-1963),taxmn(:,T2-1963),taxmn(:,T3-1963)];
Type = (1:M)';
fig_Mtaxn = figure;
Mtaxn1 = plot(Type,mtax,'LineWidth',0.8);
Mtaxn1(1).LineStyle='-';
Mtaxn1(2).LineStyle='-.';
Mtaxn1(3).LineStyle='--';
xlabel('Household type')
lgdmt = legend(mt_lgd, 'Location', 'Northwest');
lgdmt.Box ='off';
set(gca,'YGrid','on')
box off
saveas(fig_Mtaxn, fullfile(fname, 'fig_mirrlees_ltax_ext' ), 'epsc');  

 
