% Load Autor skill premium and skill-unskill worker ratio data
clear;clc
[data,title,~]=xlsread('Autor.xlsx','Sheet1','A1:G51');  
year = data(:,1);
effectu = data(:,6);
sp_data = data(:,3); suhr = data(:,7);
T =180;
ext_ind =(51:83)';
avg_sp_growth = mean(diff(log(sp_data(end-10:end))));
avg_efu_growth = mean(diff(log(effectu(end-10:end))));

sp_growth = (1+linspace(avg_sp_growth, 0, length(ext_ind))');
efu_growth =(1+linspace(avg_efu_growth, 0, length(ext_ind))');

sp_ext = sp_data(end)*facprod(sp_growth);
efu_ext = effectu(end)*facprod(efu_growth);

sp_data_ext1 = [sp_data; sp_ext];
efu_data_ext1= [effectu;efu_ext];
SSperiod = T-length(efu_data_ext1);

% Extend  data to T period
sp_data_ext = [sp_data_ext1; sp_data_ext1(end)*ones(SSperiod,1)];
efu_data_ext =[efu_data_ext1;efu_data_ext1(end)*ones(SSperiod,1)];
 
lnsp = log(sp_data);
Nt =40 ;    % Set types
Theta = linspace(0,19,Nt)';            % type of workers, this can be easily normalize to (0,1)
Pi =   ones(length(Theta),1)/length(Theta);  %  Populatin mass of each type worker, uniform distribution 
talent = [Theta,Pi];                                     % Talent set  is combined with type and population mass
cumpi = cumsum(Pi);    % cumulative  mass of type of workers
threshold = cumpi-Pi(1)/2;
 
thrm = repmat(threshold,1,T);
eftum = repmat(efu_data_ext',Nt,1);


stef = zeros(Nt,T);
stef(thrm>eftum) = 1;
index_u_data =  sum(stef,1)'  ;    
index_u_data(1) = index_u_data(2);
index_s_data = index_u_data+1;
Uratio = cumpi(index_u_data);
Sratio = 1-Uratio;

 %%
 % Apply step function to approximate  skilled worker's ratio
figure
plot(Sratio(1:58),'LineWidth',1.1)
hold on
plot(efu_data_ext(1:58),'--','LineWidth',1.1)
legend('data','model','Location','NorthWest')
 
 
locc = cd;
save([locc,'\dataid.mat'],   'index_s_data', 'sp_data_ext' , ...
                                          'efu_data_ext', 'talent'   )
 

