% Collect the data of qt and tax rates
clear
clc
%Beginning period: 1963
T =180;
ssperiod = 96;

% Price of equipment 
[qtq,~,~] = xlsread('PERIC2020.xls','FRED Graph', 'B12:D227');

nqtq = length(qtq(:,3)) ;   %  length of   quarterly data
qty = mean(reshape(qtq(:,3), 4, nqtq/4)',2)/ mean(qtq(1:4));

 
% Collect  tax rates  from McDaniel's excel sheet.
[tk_us,usak,~]=xlsread('McDaniel_tax_update_12_15_14.xlsx','tauk','P15:P65'); % McDanial Tax Rates during 1963-2013
[tinc_us,usainc,~]=xlsread('McDaniel_tax_update_12_15_14.xlsx','tauinc','P15:P65'); % McDanial Tax Rates during 1963-2013
[tss_us,usass,~]=xlsread('McDaniel_tax_update_12_15_14.xlsx','tauss','P15:P65'); % McDanial Tax Rates during 1963-2013
tn_us = tinc_us + tss_us;
tn_us_ext = [tn_us ; tn_us(end) * ones(T - length(tn_us),1)];
tk_us_ext = [tk_us ; tk_us(end) * ones(T - length(tk_us),1)];

% Estimate growth rate of qt and extend the path
dq =  diff(log(qty));       
grq = mean(dq(end-4:end));  
 
q1_ext1 = qty(end)*facprod(1+linspace(grq,0,T - length(qty) - ssperiod)');
q1_ext2 = q1_ext1(end)*ones( ssperiod ,1) ;
 
q2t =[qty; q1_ext1;q1_ext2];
locc = cd;

save('data.mat', 'q2t','tn_us_ext', 'tk_us_ext','qtq');
  
 

