function [Udiff, dICf] = ICfun2(c,n, x, Lambda, parmf, parmU, talent, parmtt, index)
% IC constraint part and derivative on labor, capital equipment 
% Notice that Lambda(1)=0

global beta

T = size(c,2);  %  length of time
Theta = talent(:,1);  PI = talent(:,2);
M = size(talent,1);

pu = parmtt(:,:,1);   
ps = parmtt(:,:,2);

zu  = lprod(Theta,pu);  %    MxT matrix
zs   = lprod(Theta,ps);   %   MxT matrix

Lambda_ld = [Lambda(2:end);0];  % 2,3,4...,M+1

[Sindx, Uindx, PIS, PIU] = indf(index', PI); 
% Only keep the index at threshold
Sindx_pre = [Sindx(2:end,:);ones(1,T)] ; 
Sindx_ld = [zeros(1,T);Sindx(1:end-1,:)];
ind_minu =Sindx_pre - Sindx ; % keep the original threshold;
ind_mins = Sindx-Sindx_ld;

[~, ~, ~, ws,wu] = korv1(x, parmf) ;
%[~,~,dws,dwu] = dkorv1(x,parmf);
zs_threshold = sum(zs.*ind_mins,1)';
zu_threshold = sum(zu.*ind_minu,1)';

[wr,dwrLu, dwrKe, dwrLs] = wp1(x,parmf,zs_threshold,zu_threshold);   
 
 

 % derivative on wage ratio  on threshold;
dwr =  dwrLu'.*zu.*PIU + dwrLs'.*zs.*PIS;


%[Sindx2,~,~,~] = indf(  (index+1)', PI);
%idxstar = Sindx - Sindx2;
ewage = zs.*Sindx.*ws' + zu.*Uindx.*wu';
% The row of  wage array is always  M
ewage_ld= [ewage(2:end,:) ;  ewage(end,:)];       
xi_tld =  ewage_ld./ewage;


% check IC constraint
c_true = [c(2:end,:) ; c(end,:)]   ;    
n_true = [n(2:end,:); n(end,:)];            % type 2, 3, 4 ... M, M+1
c_mic = c ;     % type 1, 2, 3,...M
n_mic = n ./xi_tld;

[Utrue,~,~] =util_mat(c_true,n_true,parmU);   % MxT matrix 
[Umic,~, unmic] =util_mat(c_mic, n_mic,parmU); % MxT matrix

V_true = inf_sum(Utrue',beta);       
V_mimic = inf_sum(Umic',beta);

Udiff = V_true(:,1:end-1) -V_mimic(:,1:end-1) ;  % Choose  1: M-1

f1 = Lambda_ld.*unmic.*1./xi_tld ; % (MxT)  


 
wcp = sum(Lambda_ld.*ind_minu.*unmic .* n_mic.* (1./xi_tld),1); 
f2 =  wcp.*dwr ;%???

dICf.n = f1-f2;
dICf.Ke = wcp.*dwrKe';
 
 
end

