function ff = Trans_fb( x ,parmf, parmU, parmP , inik0, pist, piut, zst , zut, qt )
% Transitional dynamic under first best case

global  delta_s  delta_e   beta

gamma_c = parmU(1);  

psis =parmP(1);
psiu =parmP(2);
G = parmP(3);


 
T = size(qt,1);   % T must larger than 1

XX =  reshape(x(1:end-1), T,5);
Ksp =  XX(:,1); zNu = XX(:,2);
Kep = XX(:,3); zNs =XX(:,4);
C = XX(:,5);


% consumption share
os =  x(end) ;
ou = (1 - os*pist(1) )/piut(1);


% Initial Asset definition inik0 = [kss0 , kes0 ] ; 
%                                                    [ksu0,  keu0] ;
kss0 = inik0(1,1);   kes0 = inik0(1,2); 
ksu0 =inik0(2,1);    keu0 = inik0(2,2);
  



Ks0 = kss0*pist(1) + ksu0*piut(1);
Ke0 = kes0*pist(1) + keu0*piut(1);
Ks = [Ks0; Ksp(1:T-1)];
Ke = [Ke0; Kep(1:T-1)];


% Factor Prices
x0 =[Ks ,  zNu, Ke,  zNs];
[Y, rs, re, ws, wu] = korv1(x0, parmf);


% Marginal Utility function ( consumption and Labor) and Utility
xst = pist.*zst;  xut = piut.*zut;
ns = zNs./(xst) ; nu = zNu./(xut) ;
cs = C*os;
cu = C*ou;


[~, ucs, vns, ~,~] = util1([cs,ns],parmU);
[~ ,ucu,vnu , ~,~] =util1([cu,nu],parmU);

Gammas = psis*ucs ;
Gammau =psiu*ucu  ;
 



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Derivative of Ramsey first best
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Intertemporal conditions
EuqKs =  Gammas.*(rs + 1-delta_s);
fks = - Gammas  + beta*fop(EuqKs) ;

EuqKe =  Gammas.*(re + (1-delta_e)./qt);
fke = Gammas./qt  - beta.*fop(EuqKe) ;

% Intratemporal conditions 
fns =  psis  .*vns   ...
            +Gammas .*ws.*zst  ;

fnu = psiu .*vnu   ...        
            +Gammau.*wu.*zut ;

% Resource constraint
frc = (1-G)*Y   + (1-delta_e)*Ke./qt  + (1-delta_s).*Ks ...
       - C  -Kep./qt - Ksp  ;

% Distribution between  skill and unskilled workers, FOC on os
fos = psis*os.^(-gamma_c) - psiu.*ou.^(-gamma_c).*(pist./piut); % chain rule


ff =[fks; fke; fns; fnu; frc; fos];

end