function ss = sssb_korv1(x , parmf, parmU, parmP, pis, piu, zs,zu,q)
global  delta_s delta_e beta 
 
vflag =parmU(4);
psiu = parmP(1);
psis = parmP(2);    %  including population ratio
G    = parmP(3);



% The variables we have to solve,
Ks=x(1);
zNu=x(2);   % aggregate effective unskilled labor supply 
Ke=x(3);
zNs=x(4);   % aggregate effective skilled labor supply
C=x(5);
Lambda_s = x(6); % IC  multiplier for unskilled worker
%Lambda_u =0;


u= reshape(x(1:4)',1,4);  
[Y, rs, re, ws, wu] = korv1(u,parmf);
[xi,xi_zNu,xi_Ke, xi_zNs] = wp1(u,parmf,zs,zu) ;

xs = pis*zs;
xu = piu*zu;

xi_ns = xi_zNs.*xs;
xi_nu = xi_zNu.*xu;

 
 
% Compute the additional terms in IC constraint
toln = 1e-7;
if vflag ==1
    ns = min(1-toln,zNs/(xs)); % individual skilled labor supply
    nu = min(1-toln,zNu/(xu)); % individual unskilled labor supply
else
    ns = zNs/xs;
    nu =zNu/xu;
end

%  Skill and unskilled consumption ratio
sweight = pis*psis + Lambda_s;
uweight = piu*psiu - Lambda_s;
[os,ou] = cratio([sweight, uweight],pis,piu,parmU);

cs = os*C;
cu = ou*C;
 
[Uss ,ucs, vns] = util1([cs,ns],parmU);
[~,ucu, vnu] = util1([cu,nu],parmU);
[Usu, ~, vnsu] = util1([cu,nu./xi],parmU);
xiic = -Lambda_s*vnsu ; %  adjust the value to positive


Gammas = (psis*pis + Lambda_s)*ucs ./pis ;
Gammau = (psiu*piu - Lambda_s)*ucu ./ piu;
% I take average between skilled and unskill marginal utility of consumtpion
Gamma = (Gammas + Gammau)/2;    


% Systems of equations
% Euler equation: Capital structure
if parmf(1) ==0
ss(1) = Ks;    
else
ss(1) = rs+1-delta_s-1/beta ;
end

% FOC on unskilled worker
ss(2) = Gamma*wu*xu +xiic*(1/xi - nu/(xi^2) *xi_nu )+ (psiu*piu)*vnu ;


% Euler equation: Capital equipment
ss(3) = beta*(Gamma.*(re +(1-delta_e)/q ) - xiic*( nu/(xi^2) * xi_Ke )  )...
            - Gamma/q;

% FOC on skilled worker
ss(4) = Gamma*ws*xs   - xiic*(  nu/(xi^2)*xi_ns )...
    +(psis*pis + Lambda_s)*vns;

% Resource constraint
ss(5) = (1-G)*Y - delta_s*Ks-(delta_e/q)*Ke-C;

% Equation 6: IC constraint for skilled labor % check (IC constraint)
ss(6) =  (Uss - Usu)/(1-beta)   ;  % If Vss< Vus, it implies IC constraint binding
ss = ss';
end