function [PHI_C, PHI_RC, PHI_RC0,...
                PHI_L, PHI_RL, PHI_RL2] = PNweight_R(phi, Psi ,parmU,parmP,  talent, parmtt , index, A0)

% Ramsey Pareto Negishi weight of  consumption,   skilled and unskilled labor supply
% iniA0 : initial Asset  distribution
% phi is the inverse of  Pareto weight; 
%  length of  index should be equal to  [~,~, T] = size(parmtt)
Theta = talent(:,1);
PI = talent(:,2);
NN = length(PI);
psi = parmP.weight;
T = length(index); 
pu = parmtt(:,:,1);
ps = parmtt(:,:,2) ;
zs =  lprod(Theta,ps);
zu = lprod(Theta,pu);

gamma_c = parmU(1);
gamma_n = parmU(2);

cpw = (1-gamma_c)/gamma_c;


R_weightC = PI.*(psi+(1-gamma_c)*Psi)  ;
R_weightC0A = PI.*Psi.*A0 ;
R_weightC0  =PI.*Psi;

PHI_C.f =  (sum( phi.^(1./gamma_c) .*PI )).^(gamma_c)   ;
PHI_C.df = PI.*(phi./PHI_C.f).^(cpw); 



phi_rcf =  sum(R_weightC.*phi.^( cpw  ));

PHI_RC.f =  phi_rcf .*  (PHI_C.f).^( -cpw ) ;
PHI_RC.df =   (PHI_C.f).^( -cpw ).*R_weightC.*( cpw  ).*phi.^( cpw -1) + ...
                        phi_rcf.*( -cpw).* (PHI_C.f).^( -cpw -1 ).*PHI_C.df ;

                          
PHI_RC0.f = PHI_C.f .*R_weightC0./phi ;   
PHI_RC0.f2 = PHI_C.f./phi;   


PHI_RC0.df = sum(R_weightC0A./phi) .* PHI_C.df + ...    % including asset
                        PHI_C.f .* R_weightC0A .* (-1).*phi.^(-2) ;


                    
%  Labor part  :    task s and task u


[Sindx, Uindx, PIS, PIU] = indf(index', PI);
phi_mat = repmat(phi,1,T);
qphis = min( phi_mat.* (1./zs) ,  1/eps  );  % Avoid NaN case , all are matrix
qphiu = min( phi_mat.* (1./zu)  ,  1/eps  );
qpis = PIS.*zs;
qpiu = PIU.*zu;

PHI_L.sf = sum( qpis.*qphis.^(1/gamma_n) ).^(gamma_n) ; % 1 x T function
PHI_L.uf = sum(qpiu.*qphiu.^(1/gamma_n)).^(gamma_n);  % 1 x T  function

lpw = (1-gamma_n)/gamma_n;
PHI_L.dsf = PIS.*(qphis./PHI_L.sf).^lpw;
PHI_L.duf =PIU.*(qphiu./PHI_L.uf).^lpw;



R_weightL = repmat(PI.*(psi + (1-gamma_n)*Psi ),1,T) ;
R_weightL2 =   repmat(PI.*Psi,1,T);


PHI_RL.sf = sum(R_weightL.* (qphis./PHI_L.sf).^lpw  .*Sindx);
PHI_RL.uf = sum(R_weightL.*  (qphiu./PHI_L.uf).^lpw.* Uindx) ;

% Derivative
PHI_RL.dsf = repmat( sum(R_weightL.* (qphis).^lpw  .*Sindx),NN,1).*Sindx.*...
                     (-lpw).* PHI_L.sf.^(-lpw-1)  .* PHI_L.dsf + ...
                    PHI_L.sf .^(-lpw) .* R_weightL.*lpw.*qphis.^(lpw-1)./zs.*Sindx;
                 

 PHI_RL.duf = repmat( sum(R_weightL.* (qphiu).^lpw  .*Uindx),NN,1).*Uindx.*...
                     (-lpw).*PHI_L.uf .^(-lpw-1) .*PHI_L.duf+ ...
                     PHI_L.uf .^(-lpw) .* R_weightL.*lpw.*qphiu.^(lpw-1)./zu.*Uindx; 

                 
PHI_RL2.sf  = sum(R_weightL2.*(PHI_L.sf ./qphis).*Sindx);
PHI_RL2.uf  = sum(R_weightL2.*(PHI_L.uf./qphiu).*Uindx); 


PHI_RL2.dsf = repmat( sum(R_weightL2.*(1./qphis).*Sindx),NN,1 ).*Sindx.*PHI_L.dsf + ...
                          PHI_L.sf .*R_weightL2.*(-1).*qphis.^(-2)./zs.*Sindx;
 
 PHI_RL2.duf = repmat( sum(R_weightL2.*(1./qphiu).*Uindx),NN,1 ).*Uindx.*PHI_L.duf + ...
                          PHI_L.uf.*R_weightL2.*(-1).*qphiu.^(-2)./zu.*Uindx;
 
end
