function [ HC, dHC, HC0, dHC0] = hct(x, theta , parmU, parmP, pist, piut)
%Characterize  distribution part of consumption;

gamma_c = parmU(1);
psis = parmP(1);
psiu = parmP(2);

os = x(1);
ou = x(2);

theta_s = theta(1) ;
theta_u = theta(2);

% utility part
[~, duos ,~,   d2uos,~ ] = util1([os,0],parmU) ;
[~, duou ,~,  d2uou,~ ] = util1([ou,0],parmU);

uos = os.^(1-gamma_c);
uou =ou.^(1-gamma_c);
ovec = [psis+theta_s*(1-gamma_c) , ... 
              psiu+theta_u*(1-gamma_c)]  ; % coefficient part

          
HC  =  ovec*[uos; uou];

dou_os = - pist./piut;  % relationship between ou and os
         
dHC = (1-gamma_c)*ovec*[duos; duou*dou_os];

%(1-gamma_c)*[os^(-gamma_c) , -ou^(-gamma_c)]*...
%                                   [psis+(1-gamma_c)*theta_s ;   psiu+(1-gamma_c)*theta_u] ;

HC0   = [ theta_s*duos    ,theta_u*duou]  ;  % HC0 is a vector
dHC0 =[  theta_s*d2uos  ,theta_u*d2uou*dou_os]; % dHC0 is a vector

end

