function [ A0 ,   dA_Ns,  dA_Nu  ] = iniA0( x0, iniK0, parmf, q0,LT,tk0)
% Initial asset term and its partial derivative
global delta_e   delta_s


%iniK0 is initial asset matrix  
%                [kss0     kes0 ]
%                [ksu0     keu0]


 % x0 =[Ks, Nu, Ke, Ns]
[~,rs0,re0,~,~] = korv1(x0, parmf) ;

%tk0 = 0.341; 
R0 = [1 + (1-tk0)*(rs0 - delta_s) ; ...
          1/q0 + (1-tk0)*(re0  - delta_e/q0)] ;
if rs0 ==0
    R0(1) =0;
end
 
% LT is   2x1 vector
A0 = iniK0*R0 + LT  ;                               % [As0 ; Au0]
%LT is 2x1 vectors


[drs, dre] = dkorv1(x0 , parmf); % derivative of rs and re

dR_dNs = (1-tk0)*[ drs.Ns ; dre.Ns ];

dR_dNu = (1-tk0)*[drs.Nu;  dre.Nu] ;
             
% For using derivative at t=0
dA_Ns = iniK0*dR_dNs;   % 2x1 matrix Ors re  ns L
dA_Nu =iniK0*dR_dNu;   %2x1 matrix  Ors re  nu L

end