function [ A0 ,   dA_Ls,  dA_Lu  ] = iniA0_tt( x0, dfA, parmf, q0,LT,tk0)
% Initial asset term and its partial derivative
% dfA :  distribution of asset,  sum(PI.*dfA) = 1
global delta_e   delta_s



[~,rs0,re0,~,~] = korv1(x0, parmf) ;
R0 = [1 + (1-tk0)*(rs0 - delta_s) ; ...
          1/q0 + (1-tk0)*(re0  - delta_e/q0)] ;
if rs0 ==0
        R0(1) =0;
end
 
% LT is   2x1 vector
Ks0 = x0(1);  Ke0 = x0(3);
ks0 = dfA*Ks0;
ke0 = dfA*Ke0;
iniK0 = [ks0,ke0] ;    % Nx 2 array

A0 = iniK0*R0 + LT  ;        % Total initial asset
[drs, dre] = dkorv1(x0 , parmf); % derivative of rs and re

dR_dLs = (1-tk0)*[ drs.Ns ; dre.Ns ];

dR_dLu = (1-tk0)*[drs.Nu;  dre.Nu] ;
             
% For using derivative at t=0
dA_Ls = iniK0*dR_dLs;    
dA_Lu =iniK0*dR_dLu;    

end