function y = solve_Ramsy( x ,parmf, parmU, parmP , inik0, pist,piut, zst , zut, qt )
% Solving single labor taxes rates :   


global    delta_s    delta_e    beta

 
psis =parmP(1);
psiu =parmP(2);
G = parmP(3);
tk = parmP(4);  % initial capital tax rates

%alpha = parmf(1);    % [ alpha ;  sigma; mu ; rho ; lambda]
T = size(qt,1);   % T must larger than 1

XX =  reshape(x(1:end-4), T,6);
Ksp =  XX(:,1); zNu = XX(:,2);
Kep = XX(:,3); zNs =XX(:,4);
C = XX(:,5);  Mp = XX(:, 6);  % multiplier 
 
 

% consumption share
os =  x(end-3) ;
ou = (1 - os*pist )/piut;

% Implementability multipliers  (skill, unskill)
theta_s = x(end-2);  
theta_u = x(end-1);
LT = x(end) ;  % inidividual  lump-sum transfer


% Initial Asset definition inik0 = [kss0 , ksu0 ; kes0 , keu0] ;
kss0 = inik0(1,1);  kes0 = inik0(1,2);  
ksu0 =inik0(2,1);  keu0 = inik0(2,2);

Ks0 = kss0*pist + ksu0*piut;
Ke0 = kes0*pist + keu0*piut;
Ks = [Ks0; Ksp(1:T-1)];
Ke = [Ke0; Kep(1:T-1)];


% Factor Prices  and initial return
x0 =[Ks ,  zNu, Ke,  zNs];
[Y, rs,re, ws,wu] = korv1(x0, parmf);

Rs0  =(1+           (1-tk)*(rs(1)  -delta_s));
Re0  =(1/qt(1) +(1-tk)*(re(1)  - delta_e/qt(1) )) ;


% Marginal Utility function ( consumption and Labor) and Utility
xst = pist.*zst  ;  xut = piut.*zut;


toln = 1e-7;
vflag = parmU(4);
if vflag ==1
    ns = min(1-toln,zNs./(xst)); % individual skilled labor supply
    nu = min(1-toln,zNu./(xut)); % individual unskilled labor supply
else
    ns = zNs./xst;
    nu =zNu./xut;
end

 
cs = os*C         ;  cu = ou*C;

[~, ucs, vns,  ~ , vnns]  = util1([cs,ns] ,parmU);
[~, ucu, vnu, ~, vnnu] = util1([cu,nu],parmU);

els_s  =  vns ./  (vnns.* ns); 
els_u  =  vnu ./ (vnnu.* nu); 

[~,UC , ~, UCC,~] = util1([C, zeros(T,1)], parmU);
% Marginal utility of consumption
gamma_c = parmU(1);
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial asset term on derivative
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


xos = [os;ou];
thetaa = [theta_s ; theta_u];
[ HC, dHC_os, HC0, dHC0_os] = hct(xos, thetaa , parmU, parmP, pist, piut)   ;      


% Initial asset and its derivative
xx0 = [Ks(1),zNu(1), Ke(1), zNs(1) ];  % initial  value
[ A0 ,   dA_Ns,  dA_Nu  ] = iniA0( xx0, inik0, parmf, qt(1),LT,tk);

% initial term is   HC0A0 , derivative on 

UC0 = UC(1);  % initial marginal utility of consumption
UCC0 = UCC(1);


dAos = dHC0_os*UC0*A0;
dAC0 = [ HC0*UCC0*A0   ;zeros(T-1,1)] ;


Ans0 =   HC0*UC0*dA_Ns.*xst(1) ;  % FOC on initial period, HC0 contain theta_s, theta_u
Anu0 =   HC0*UC0*dA_Nu.*xut(1);
Ans = [Ans0; zeros(T-1,1)];
Anu = [Anu0; zeros(T-1,1)];

ucAs0=ucs(1)*A0(1);
ucAu0=ucu(1)*A0(2);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     Derivative of   intratemporal conditions                         
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


xx1 = [Ks, zNu, Ke, zNs] ;
cshare = [os;  ou] ;
[f1, df1ns, df1nu, df1Ke , df1os] = dintra(xx1, cshare,  parmf, parmU , ...
                                                                        pist, piut, zst, zut);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Derivative of Ramsey
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Gamma = HC.*UC - dAC0;  % derivate on C; 


% Intratemporal conditions 
fns = ( psis + theta_s* (1+  1./els_s)  ).*vns -  Ans  ...
            +Gamma.*ws.*xst   + Mp.*df1ns  ;

fnu =( psiu + theta_u* (1+  1./els_u)  ).*vnu -  Anu  ...        
            +Gamma.*wu.*xut  +  Mp.*df1nu  ;

        
% FOC on equipment and capital

Euke = Gamma.*(re + (1-delta_e)./qt)  +  Mp.*df1Ke     ;
Euks = Gamma.*(rs + (1-delta_s) );


if parmf(1) ==0 % if alpha ==0 , shut down foc on ks
    fks = zeros(T,1);
else
    fks =  -Gamma + beta*fop(Euks) ;
end



fke =  - Gamma./qt  + beta.* fop(Euke);


% Resource constraint
 
frc = (1-G)*Y   + (1-delta_e)*Ke./qt  + (1-delta_s)*Ks - C  -Kep./qt - Ksp  ;


% Lump-sum tax criterion :
%implementability conditions and derivative on T
 
Es  = impbc1([cs,ns], parmU); % flag: check steady state
Eu =  impbc1([cu,nu], parmU);

% Implementability constraint
fips =  Es - ucAs0;
fipu = Eu - ucAu0;



% FOC on skilled and unskilled consumption share
LFUC = inf_sum(UC.*C./(1-gamma_c) , beta);
fos = dHC_os*LFUC - dAos   + inf_sum(Mp.*df1os,beta) ;  % LFU : life-time utility of consumption

% flt  % lump-sum transfer
flt = theta_s*ucs(1) + theta_u*ucu(1) ;

 y1 =[fns; fnu; fke; fks; frc; fips; fipu ; fos; flt ] ;
 y=[y1;f1];
end


function [ f1, df1ns, df1nu, df1Ke , df1os ] = dintra(x,  cshare, parmf, ...
                   parmU ,  pis, piu ,zst, zut )
% Derivative of Intratemporal constraints at each period, 2020.04.10
T = length(zst);
% x = [Ks, zNu, Ke, zNs ]

[xi ,  xi_Nu, xi_Ke, xi_Ns] = wp1( x,parmf, zst,zut );
os = cshare(1);  ou = cshare(2);

zNu = x(:,2);  
zNs = x(:,4);


xst = pis.*zst;
xut = piu.*zut;
 
toln = 1e-7;  vflag = parmU(4);
if vflag ==1
    ns = min(1-toln,zNs./(xst)); % individual skilled labor supply
    nu = min(1-toln,zNu./(xut)); % individual unskilled labor supply
else
    ns = zNs./xst;
    nu =zNu./xut;
end

 oss  = os*ones(T,1);   ouu =ou*ones(T,1);
[~, ucos, vns, uccos, vnns] = util1([oss, ns], parmU) ;
[~, ucou, vnu, uccou, vnnu] = util1([ouu, nu], parmU) ;


f1 = log( -vns./ ucos) -  log(  -vnu./ ucou   .* xi ) ;


xi_ns = xi_Ns.*xst;
xi_nu= xi_Nu.*xut;
df1ns  =    vnns./vns - 1./xi .*xi_ns ;
df1nu  =  - vnnu./vnu - 1./xi .* xi_nu;      
df1Ke =  - 1./xi .* xi_Ke;

dou_os = - pis./piu ;
df1os =    -   uccos./ucos   + uccou./ucou .* dou_os;

end
