function [U,  uc,  un,  ucc, unn] = util1(x, parmU, varargin)
% utility has the form  of   u(c)- v(n)

if nargin ==2
    PIZ = 1;
else
    PIZ = varargin{1};
end

gamma_c = parmU(1) ; 
gamma_n = parmU(2) ;
chi = parmU(3);
idx = parmU(4);  % choose leisure of  labor supply

c = x(:,1);
n = x(:,2);


if gamma_c == 1
  UUC = log(c)   ;
else
  UUC =  c.^(1-gamma_c) ./ (1-gamma_c)  ;   
end    

if  idx ==1  % leisure
    if gamma_n ==1
        UUN = chi*log(PIZ-n) ;
    else
        UUN =  chi*(PIZ-n).^(1-gamma_n)./(1-gamma_n)  ;
    end 
    un= - chi* (PIZ-n).^(- gamma_n) ;  % Marginal utility of labor supply
    unn =  -chi.*(gamma_n)*(PIZ-n).^(-gamma_n -1 );
else
    UUN =   -  chi* n.^(gamma_n)/gamma_n ;  % labor supply
    un= - chi* n.^(gamma_n-1);
    unn = - chi* (gamma_n-1).*n.^(gamma_n-2);    
end

U = UUC + UUN ;          % Utility
uc =  c.^(-gamma_c);    % Marginal utility of consumption
ucc = -gamma_c.*c.^(-gamma_c-1);


end

