function [U,  uc,  un,  ucc, unn] = util_mat(c,n, parmU)
% utility has the form  of   u(c)- v(n)

gamma_c = parmU(1) ; 
gamma_n = parmU(2) ;
chi = parmU(3);
idx = parmU(4);  % choose leisure of  labor supply



if gamma_c == 1
  UUC = log(c)   ;
else
  UUC =  c.^(1-gamma_c) ./ (1-gamma_c)  ;   
end    

if  idx ==1  % leisure
    if gamma_n ==1
        UUN = chi*log(1-n) ;
    else
        UUN =  chi*(1-n).^(1-gamma_n)./(1-gamma_n)  ;
    end 
    un= - chi* (1-n).^(- gamma_n) ;  % Marginal utility of labor supply
    unn =  -chi.*(gamma_n)*(1-n).^(-gamma_n -1 );
else
    UUN =   -  chi* n.^(gamma_n)/gamma_n ;  % labor supply
    un= - chi* n.^(gamma_n-1);
    unn = - chi* (gamma_n-1).*n.^(gamma_n-2);    
end

U = UUC + UUN ;          % Utility
uc =  c.^(-gamma_c);    % Marginal utility of consumption
ucc = -gamma_c.*c.^(-gamma_c-1);


end

