% Mirrleesian taxation  with capital-skilled complementary : Benchmark case
qt = q;

zst = 1;  zut =1               ;  % control labor productivity;
pist =pis0;  piut =piu0;               % control population ratio
%  Pareto weight  (including population ) 
psis =1 * pist ;    psiu = 1*piut;
parmP =[psis;psiu;Gr];
 

%  take 6 grids; we will replace 0.99 by 1 later (line 136 - 143)
rhos   =  -0.495;   
sigmas = [rhos ;  -0.25 ; 0 ; 0.401; 0.75; 0.99 ];    
sgn = length(sigmas);    
xgrid_M =zeros(5*T+1,  sgn );




%%%%%%%%%%%%%%%%% First Best Case steady state %%%%%%%%%%%%%%%%%%%
 % set empty array 
solfb= zeros(T,5);     errfb = ones(T,1); 
solsb =zeros(T,6);     errsb = ones(T,1);
optionfb = optimset('Display','off');
ICss = zeros(T,1);
ttest3 = zeros(sgn,1);

for jj =1:sgn
    parmfs0 = [alpha; sigmas(jj);mu; rhos ; lambda];
    x1 =[Kss0;Nus0;Kes0;Nss0;Css0];    % Initial guess
    xx1 = x1;
 
 
        for nn= 1:T
            [xxfb,errss] = fsolve('ssfb_korv',x1,optionfb,parmfs0,parmU,parmP,...
                                                  pis0,piu0,zst,zut,qt(nn));
                                              
            [~,~,ICss(nn)] =    ssfb_korv(xxfb,  parmfs0,parmU,parmP,pis0,piu0,zst,zut,qt(nn));                                          
            errfb(nn) = norm(errss,inf);
            solfb(nn,:)= xxfb';                                                  
            Wx1 = xxfb;                                                  
        end

 
    % Check  IC  constraint hold or not
    %  find out  skill and unskilled consumption
    [os, ou] = cratio([psis,psiu], pis0,piu0,parmU);
    csfb = os*solfb(:,5);  cufb = ou*solfb(:,5);  
    FB = [solfb(:,1:4) , csfb, cufb];
    FB2 = [solfb(1,1:5), 0];
    [FB_alc, FB_price, FB_tax] =allc(FB,parmfs0,parmU,  ...
                                                           pis0,piu0,zs0,zu0,qt);
                                                                                                                 
    csfb = FB_alc.cs;  cyfb = FB_alc.cu;   % consumption
    nsfb = FB_alc.ns;  nufb =FB_alc.nu;  % labor supply
    xifb   = FB_price.wp;                          % skill premium

    Uss = util1([csfb,nsfb],parmU);   Usu = util1([cufb, nufb./xifb],parmU);
    Vss = Uss./(1-beta) ;  Vsu = Usu./(1-beta);
    IC = max(Vss- Vsu); % To make sure IC constraint binding, must be negative
    max(ICss)
 

%%%%%%%%%%%%%% Mirrlees steady state %%%%%%%%%%%%%%%%%%%%%%%%%
 
 
    solsb0 = [ xx1  ;0];

    %ssba= zeros(T,1)  ssb
    for nn1=1:T
        [xxsb, err] =fsolve('sssb_korv1',solsb0,optionfb,parmfs0,parmU,parmP,...
                                              pis0, piu0, zst,zut,qt(nn1));           
        solsb(nn1,:)=xxsb'  ;
        errsb(nn1) = norm(err,inf)   ;                                 
        solsb0 = xxsb;
    end


    sssb_korv1(solsb0,parmfs0,parmU,parmP,...
            pis0,piu0, zst,zut,qt(nn1) );
  
         
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Compute transitional dynamics for each  sigma
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    optionT = optimset('Display','iter','MaxFunEvals',10^12,...
    'MaxIter',100,'TolFun',1e-6,'LargeScale','on');     % option for solving  transitional dynamics

    K0  = [Kss0, Kes0] ; 
    % check  the function
    xt002 = [solsb(1:T*5)' ;  solsb(end) ];  % transform the result;

    ii =jj;
    


    parmfs = parmfs0;

    % Lower and upper bound  of our  allocation
    LBM = [zeros(5*T,1); 1e-5];          % i.e., Ks,Nu,Ke,Ns,C, (5T*1), Lambda for skilled worker
    UBM = [50*ones(5*T,1);psiu];
    if  parmfs(2) ~=-0.495
       UBM(2*T+12) = 0.35 ;
    end
 

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
    %%%    Apply lsqnonlin to solve the transitional dynamics 
    % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 


    test2 =  Trans_IC(xt002,parmfs,parmU,parmP,K0, ... 
                                      pis0, piu0,zst,zut,qt)  ;

    % Solving procedure                
    [xt_sb2, fvalt2] = lsqnonlin('Trans_IC',xt002,LBM,UBM,optionT,...     % we use the HP filter qt  
                       parmfs,parmU,parmP,K0, pis0, piu0 ,zst,zut,qt);                 
                  
    [errr, ~ , ~] =  Trans_IC(xt_sb2,parmfs,parmU,parmP,K0, ... 
                                      pis0, piu0,zst,zut,qt)   ;                 
 
    % Convert the solution xt_sb2 to  allocation, tax rates and  factor prices                                  
    [alcm(ii),  pricem(ii), taxm(ii)] = allc_M(xt_sb2,parmfs,parmU,parmP,...
                                                       pis0,piu0,zst,zut,qt , K0);
                                                
    xgrid_M(:, ii) = xt_sb2;                                  
    ttest3(ii) = fvalt2;               
                                
end
 


 
% Compute the transitional dynamic when  sigma =1;
parmfs(2) =1;
sigmas(ii)=1;
xt002 =xt_sb2;
[xt_sb2, fvalt2] = lsqnonlin('Trans_IC',xt002,LBM,UBM,optionT,...     % we use the HP filter qt  
                       parmfs,parmU,parmP,K0, pis0, piu0 ,zst,zut,qt);   
[alcm(ii),  pricem(ii), taxm(ii)] = allc_M(xt_sb2,parmfs,parmU,parmP,...
                                                       pis0,piu0,zst,zut,qt , K0);
xgrid_M(:, ii) = xt_sb2;   

 
%%  Compute transitional dynamic at  different Pareto weights                                                

 
xpm = xgrid_M(:, 4) ;% sigma = 0.401;
pweight = [1;2;5];
pwn = length(pweight);
xgrid_Mp = zeros( length(xpm) ,pwn);

  

 for ij =1:pwn
    psis0 = 1/(1+pweight(ij))   ;
    psiu0 =  pweight(ij)/(1+pweight(ij)) ;
    UBM(2*T+12) = 0.355;
    parmP0 =[psis0;psiu0;Gr];

    mtest   = norm( Trans_IC(xpm,parmf,parmU,parmP,K0, ... 
                                      pis0, piu0,zst,zut,qt),inf)  ;
 
    %  solve Mirrlees under different  pareto weight ratio case
    [xsbp, fvaltp] = lsqnonlin('Trans_IC',xpm,LBM,UBM,optionT,...     % we use the HP filter qt  
                       parmf,parmU,parmP0,K0, pis0, piu0 ,zst,zut,qt);                 
 

    [alcmp(ij) ,  pricemp(ij), taxmp(ij)] = allc_M(xsbp,parmf,parmU,parmP0,...
                                                    pis0,piu0,zst,zut,qt , K0);
    xgrid_Mp(:,ij) =xsbp;

 end

%%
% Save the results and plot figures in Create_FigureM_benchmark.m
save Mirrlees_benchmark.mat


%  Function part
function [allocation, price, tax]= allc(x , parmf, parmU,...
                                                            pis, piu , zs, zu, q )
%  Revised in 2020.03.16, recover all  tax rates,  allocation , and prices
%  Compute allocation from Mirrlees
global beta delta_s delta_e
 
Ks=x(:,1);
Nu=x(:,2);   % aggregate effective labor supply of unskilled labor
Ke=x(:,3);
Ns=x(:,4);   % aggregate effective labor supply of skilled labor
cs=x(:,5);    % skilled worker's consumption share
cu =x(:,6);   % unskilled worker's consumption share


% Allocations
allocation.Ks = x(:,1);
allocation.Nu=x(:,2);   % aggregate labor supply of unskilled labor
allocation.Ke=x(:,3);
allocation.Ns=x(:,4);   % aggregate labor supply of skilled labor
allocation.cs=x(:,5);  % skilled worker's consumption share
allocation.cu =x(:,6); % unskilled worker's consumption share
allocation.C = pis*cs + piu*cu;
allocation.ns = Ns./(pis.*zs) ;
allocation.nu = Nu./(piu.*zu);


% factor prices and skill premium
u = [Ks, Nu, Ke, Ns];
[Y , rs,re,ws,wu] = korv1(u, parmf);

allocation.Y = Y;
price.rs = rs;
price.re = re;
price.ws =ws;
price.wu =wu;
[price.wp, ~,~,~] = wp1(u, parmf,zs,zu);
% Tax rates:
ns  =  Ns./(pis.*zs);
nu = Nu./(piu.*zu);

[~,ucs,uns] = util1([cs,ns] ,parmU);
[~,ucu,unu] = util1([cu,nu],parmU);

tax.s =  1+ uns./(ucs.*ws.*zs) ;
tax.u =  1+ unu./(ucu.*wu.*zu);


ucs_ld = fop(ucs);  % forward one period
rs_ld = fop(rs);
re_ld = fop(re);
q_ld = fop(q) ;

if length(cs) == 1  %  prepare to define
    tax.ks =  (1-1/beta)/(rs - delta_s) +1  ;
    tax.ke = (1-1/beta)/(q*re - delta_e) +1  ;
else
    MRS =  ucs./(ucs_ld*beta) ;
    tax.ks  =  (1-MRS)./(rs_ld - delta_s) +1 ;
    tax.ke  =  (1-MRS)./(q_ld.*re_ld -delta_e) +1 ;
end

 
end


function [allocation, price, tax]= allc_M(x , parmf, parmU,parmP,...
                                                            pis, piu , zs, zu, q , varargin)
%  Revised in 2020.03.20, recover all  tax rates,  allocation , and prices
%  Computed from competitive equilibrium
%  varargin is set initial capital K0 ;  
global beta delta_s delta_e
 
% Determine the  size of  input x
NN = numel(x)  ;   

if nargin == 9    %  I use the existence of initial value to determine steady state of transitional dynamics
x = reshape(x, NN/6, 6);
Ls =x(:,6);   % unskilled worker's consumption share    
Ks0 =[ ];
Ke0 =[ ];
else % transitional dynamics
Ls = x(end);    
x = x(:) ;    
x = reshape( x(1:end-1),  (NN-1)/5  ,5) ;   
Ks0 = varargin{1}(1);
Ke0 = varargin{1}(2);
end

Ks=[Ks0; x(:,1)];  
Nu=x(:,2);   % aggregate effective labor supply of unskilled labor
Ke=[Ke0;x(:,3)]; 
Ns=x(:,4);   % aggregate effective labor supply of skilled labor
T = length(Nu);
Ks = Ks(1:T);  Ke= Ke(1:T); 



C=x(:,5);    % skilled worker's consumption share


% I directly use the number of solution to determine  transitional dynamics
% or steady state

% Allocations
allocation.Ks = Ks;
allocation.Nu=Nu;   % aggregate labor supply of unskilled labor
allocation.Ke=Ke;
allocation.Ns=Ns;   % aggregate labor supply of skilled labor
allocation.C = C ;
allocation.Ls =Ls; % unskilled worker's consumption share

allocation.ns = Ns./(pis.*zs) ;
allocation.nu = Nu./(piu.*zu);

psis = parmP(1);
psiu = parmP(2);
[os, ou] = cratio([psis+Ls , psiu-Ls],pis,piu,parmU);
cs = os*C;
cu = ou*C;

Ke(20) = min(0.38, Ke(20));
allocation.cs = cs;
allocation.cu = cu;

% factor prices and skill premium
u = [Ks, Nu, Ke, Ns];
[Y , rs,re,ws,wu] = korv1(u, parmf);

allocation.Y = Y;
price.rs = rs;
price.re = re;
price.ws =ws;
price.wu =wu;
[price.wp, ~,~,~] = wp1(u, parmf,zs,zu);
% Tax rates:
ns  =  Ns./(pis.*zs);
nu = Nu./(piu.*zu);

allocation.ns = ns;  allocation.nu = nu;

[~,ucs,uns] = util1([cs,ns] ,parmU);
[~,ucu,unu] = util1([cu,nu],parmU);


tax.s =  1+ uns./(ucs.*ws.*zs) ;
tax.u =  1+ unu./(ucu.*wu.*zu);



if mod(NN,6) ==0
    MRS = 1/beta ;
    rs_ld = rs;
    re_ld = re;
      q_ld = q;
else
    ucs_ld = fop(ucs);
    MRS =  ucs./(ucs_ld*beta) ;
    rs_ld = fop(rs);
    re_ld = fop(re);
    q_ld = fop(q) ;
end


tax.ks = (1-MRS)./(rs_ld -delta_s) +1 ;
tax.ke = (1-MRS.*q_ld./q )./(q_ld.*re_ld - delta_e) +1;
 
end
