% Steady state  Ramsey  taxation  with capital-skilled complementary 
% Solve  transitional dynamics of Ramsey with different  sigma-rho  combination


% Planner part
psis =1 * pis0 ;    
psiu =1*piu0;
parmP =[psis;psiu;Gr];   
zst = zs0*ones(T,1);
zut = zu0*ones(T,1);
optionfb = optimset('Display','off');


%% First Part : change  parameters sigma  %%%%%%%%%%%%%%
% Production part
rhos   =  -0.495;           %  10 grids
sigmas = [rhos ;  -0.25 ; 0 ; 0.401; 0.75; 0.999 ];    %  take  6  grids; 
sgn = length(sigmas);    
rtest4 = zeros(sgn,1);
qt =q;

% Empty grid
xrgrid =zeros(  T*6+4,  sgn );


% Initial capital
AK0 =[Kss0; Kes0];

%%%%%%%Compute First Best  steady state solution for our future  initial guess %%%% 


jj=1;
x1 =[Kss0;Nus0;Kes0;Nss0;Css0];    % Initial guess  
parmfs0 = [alpha; sigmas(jj);mu; rhos ; lambda];
%ssfb_korv(x1, parmfs0,parmU,parmP,pis0,piu0,zs0,zu0,qt(nn))'
solfb = zeros(T,5);
errfb = ones(T,1);

 for nn= 1:T
[xxfb,err] = fsolve('ssfb_korv',x1,optionfb,parmfs0,parmU,parmP,...
                                                  pis0,piu0,zst(nn),zut(nn),qt(nn));
solfb(nn,:) = xxfb';
errfb(nn) = norm(err,inf);                                              
x1 = xxfb;                                                  
 end
 
 
ks0 = AK0; ku0 = AK0;
inik0 =  [ks0' ; ku0'];   
 
[os0, ~] =cratio([psis,psiu],pis0,piu0,parmU);

% First best transitional dynamics; 
thes0   =0;
theu0  =0;
LT =0;
xt0 = [solfb(:); os0];

% Step 2: transitional dynamics of Ramsey 1 
xt00 = [xt0; thes0; theu0; LT];
tk0 =tau_k;
parmG = [parmP; tk0] ;
rstest =  solve_Ramsy1(xt00,parmfs0,parmU,parmG,inik0,pis0,piu0,zst,zut,qt) ;

opr1 = optimset('Display','iter','MaxFunEvals',10^12,...
    'MaxIter',100,'TolFun',1e-8,'LargeScale','on');
 
LBR1 = [zeros( length(xt00)-3,1) ; -100 ; -100; -100 ];
UBR1 = 20 * ones( length(xt00),1);
 
 
[xr_sol, fevalr0] = lsqnonlin('solve_Ramsy1', xt00, LBR1,UBR1,opr1, ...
                                                parmfs0,parmU,parmG,inik0,pis0,piu0,zst,zut,qt);

  

%  Ramsey taxation with single labor tax rates
MP =  0.0*ones(T,1);         % multiplier
x0  = [  xr_sol(1: end-4)   ; MP ;   xr_sol(end-3:end)] ;
LBR2 = [zeros( length(x0)-3,1) ; -100 ; -100; -100 ];
UBR2 = 200 * ones( length(x0),1);

rtest3 = solve_Ramsy(x0, parmfs0,parmU,parmG,inik0,pis0,piu0,zst,zut,qt);
  

% parmfs =[alpha;sigma;mu;rho;lambda]
for ii =jj:sgn
% Solve single tax case in different sigmas
parmfs =[alpha;sigmas(ii);mu;rho;lambda];

if  parmfs(2) ~= -0.495
  UBR2(T*2+12) =0.29; 
end
rtest3 = solve_Ramsy(x0, parmfs,parmU,parmG,inik0,pis0,piu0,zst,zut,qt);

 [xr2, fevalr2] = lsqnonlin('solve_Ramsy', x0, LBR2,UBR2,opr1, ...
                                                 parmfs,parmU,parmG,inik0,pis0,piu0,zst,zut,qt);

 rtest4(ii) = norm(solve_Ramsy(xr2, parmfs,parmU,parmG,...
                                          inik0,pis0,piu0,zst,zut,qt),inf);

  
[ralc(ii), rprice(ii), rtax(ii)] = allc_R(xr2,parmfs,parmU,parmG,inik0,pis0,piu0,zst,zut,qt);

xrgrid(:,ii) =xr2;
x0 = xr2;
end

 

%% Second part : change  Pareto weight
benchmark_case =4;

xp0 = xrgrid(:,benchmark_case);
parmfp = [alpha;sigmas(benchmark_case);mu;rho;lambda];
rtest5 = norm(solve_Ramsy(xp0, parmfp,parmU,parmG,inik0,pis0,piu0,...
                                                              zst,zut,qt),inf);
                                                          
test1 = allc_R(xp0,parmfp,parmU,parmG,inik0,pis0,piu0,zst,zut,qt);                                                          
%%                                                        
 
% xr20 = xr2;
 pweight = [1;2;5];
 pwn = length(pweight);
 
 
xsol_pweight = zeros(length(xrgrid), pwn);
rtest6 = zeros(pwn,1);  % save residual
for ij =1:pwn
fprintf('Compute Pareto weight psi_u/psi_s = %1.0f  : \n',  pweight(ij))    
psis0 = 1/(1+pweight(ij))   ;
psiu0 =  pweight(ij)/(1+pweight(ij)) ;
parmP0 =[psis0;psiu0;Gr];  
parmG0 = [parmP0;tk0];     
rtestv = norm( solve_Ramsy(xp0, parmf,parmU,parmG0,inik0,pis0,piu0,...
                                                              zst,zut,qt),inf);
 
UBR2(T*2+12) =0.24 - (ij-1)*0.01;

[xrp, fevalr] = lsqnonlin('solve_Ramsy', xp0, LBR2,UBR2,opr1, ...
                                                   parmf,parmU,parmG0,inik0,pis0,piu0,zst,zut,qt);

rtest6(ij) = norm( solve_Ramsy(xrp, parmf,parmU,parmG0,inik0,pis0,piu0,...
                                                              zst,zut,qt),inf);
                                                          
[ralcp(ij), rpricep(ij), rtaxp(ij)] = allc_R(xrp,parmf,parmU,parmG0,inik0,...
                                                                     pis0,piu0,zst,zut,qt);
                                                          
xsol_pweight(:, ij) = xrp;
xp0 = xrp;
 
end
%%
save  Ramsey_benchmark.mat  


% Function part
function [allocation, price, tax]= allc_R(x ,parmf, parmU, parmP , inik0, pist,piut, zst , zut, qt )
%  Revised in 2020.04.20, recover all  tax rates,  allocation , and prices
%  Computed from Ramsey solution with single tax rates
 

global    delta_s    delta_e    beta

 
psis =parmP(1);
psiu =parmP(2);
G = parmP(3);
tk = parmP(4);  % initial capital tax rates

%alpha = parmf(1);    % [ alpha ;  sigma; mu ; rho ; lambda]
T = size(qt,1);   % T must larger than 1

XX =  reshape(x(1:end-4), T,6);
Ksp =  XX(:,1); Nu = XX(:,2);
Kep = XX(:,3); Ns =XX(:,4);
C = XX(:,5);  
Mp = XX(:, 6);  % multiplier 
 



% consumption share
os =  x(end-3) ;
ou = (1 - os*pist )/piut;

% Implementability multipliers  (skill, unskill)
theta_s = x(end-2);  
theta_u = x(end-1);
LT = x(end) ;  % inidividual  lump-sum transfer


% Initial Asset definition inik0 = [kss0 , ksu0 ; kes0 , keu0] ;
kss0 = inik0(1,1);  kes0 = inik0(1,2);  
ksu0 =inik0(2,1);  keu0 = inik0(2,2);

Ks0 = kss0*pist + ksu0*piut;
Ke0 = kes0*pist + keu0*piut;
Ks = [Ks0; Ksp(1:T-1)];
Ke = [Ke0; Kep(1:T-1)];

 

% Factor Prices  and initial return
x0 =[Ks ,  Nu, Ke,  Ns];
[Y, rs,re, ws,wu] = korv1(x0, parmf);


 

% Allocations
allocation.Ks = Ks;
allocation.Nu=Nu;   % aggregate labor supply of unskilled labor
allocation.Ke=Ke;
allocation.Ns=Ns;   % aggregate labor supply of skilled labor
allocation.C = C ;
allocation.Y =Y;
allocation.thetas = theta_s; % unskilled worker's consumption share
allocation.thetau = theta_u;
allocation.Mpt = Mp; 
 
 cs = os*C;
 cu = ou*C;

% allocation.cs = cs;
% allocation.cu = cu;
% 
% % factor prices and skill premium
 u = [Ks, Nu, Ke, Ns];
% [Y , rs,re,ws,wu] = korv1(u, parmf);
% 
% allocation.Y = Y;
 price.rs = rs;
 price.re = re;
 price.ws =ws;
 price.wu =wu;
[price.wp, ~,~,~] = wp1(u, parmf,zst,zut);

% Tax rates:
 ns  =  Ns./(pist.*zst);
 nu = Nu./(piut.*zut);
% 
 allocation.ns = ns;  allocation.nu = nu;
% 
 [~,ucs,uns] = util1([cs,ns] ,parmU);
 [~,ucu,unu] = util1([cu,nu],parmU);
% 
% 
 tax.s =  1+ uns./(ucs.*ws.*zst) ;
 tax.u =  1+ unu./(ucu.*wu.*zut);
% 


ucs_ld = fop(ucs);
MRS =  ucs./(ucs_ld*beta) ;
rs_ld = fop(rs);
re_ld = fop(re);
q_ld = fop(qt) ;

 

Reld = fop(re -delta_e./qt);
Reld2 = fop(re);
Rsld = fop(rs + -delta_s);
MRS = ucs./(beta*fop(ucs)) ;
q_ld =fop(qt);
tax.ks = (1-MRS)./Rsld +1; 
tax.ke =( 1./q_ld - MRS./qt)./Reld +1 ;

tax.ke2 =  1-(MRS./qt)./(Reld + 1./q_ld)   ;
 


end
 
 

