%  Compute  Transitional dynamics of  CE in assignment model
%  and find out  {zst} that matching data
load('Data/dataid.mat')
qt =q;    T = length(q);
 
parmT0 =[tk_us_ext, tk_us_ext, tn_us_ext, Gr*ones(T,1)];

% Set transitional target of skill premium and skilled labor ratio
sp_data_exth = hpfilter(sp_data_ext,100);
spp =  hpfilter(sp_data_ext,100); 
indp = index_s_data;   % The index define  the lowest type choosing skilled task at each period
 
zut = ones(T,1); 
zst = linspace(0.8,2.1, T)';  % initial guess  of  {zst}


% Type and density
NN = length(talent);  % load from dataid.mat
Theta = talent(:,1);
PI = talent(:,2);
FPI = cumsum(PI); 
 
% Convert the benchmark  allocation  to Assignment model allocation
piut = FPI(indp-1);   pist = 1-piut;
piu0 = FPI(index_s_data(1)-1);  pis0 =1-piu0;   zu0 =1;
parmT00 =parmT0(1,:);


[ss001,~] = fsolve('SS_korv',x00,option0,parmf,parmU,parmT00,pist(1),piut(1),zs0,zu0,...
                    qt(1),ssk);
 
% dfA00 is the distribution of asset holding between agents                
[~, ~  , ~, dfA00]=convert_CE(ss001,parmU,...
                                                    pist(1),piut(1),zs0,zu0, ssk,talent);                
                
 
ers1 = zeros(T,1);
Xss=zeros(length(x00)+ NN-1,T);
parmttss=zeros(T,2,2);
index_ss=zeros(T,1);
dfAss=zeros(NN, T);
x001 =x00; 

% compute initial distribution
it =1;

 for it =1:T
    ssk0 = 0.436/pist(it);    
    [ss00,~] = fsolve('SS_korv',x001,option0,parmf,parmU,parmT0(it,:),pist(it),piut(it),zst(it),zut(it),...
                    qt(it),ssk0);
             
    [Xss(:,it), parmttss(it,:,:)  ,index_ss(it), dfAss(:,it)]=convert_CE(ss00,parmU,...
                                                    pist(it),piut(it),zst(it),zut(it),ssk0,talent);
    [test1, ind0] = ttce_ss(Xss(:,it),parmf,parmU,parmT0(it,:),talent,...
                                        parmttss(it,:,:), index_ss(it),qt(it) , dfAss(:,it));
    ers1(it) = norm(test1,inf)       ;  % check assignment model result;                                                                                           
    x001 = ss00;
 end 
 
 
 % Guess an initial  parameters
parmut = [0,0];   parmst =[0.15,-1.0];
 
% add productivity slope of  skilled workers;
dFA0 = dfA00; % initial asset holding 
Xtss = zeros(length(test1)+2, T); 

% Set loop number error array   
it1 =1 ;    erg2 = zeros(T,1);
parmtt1 = cat(3,parmut,parmst);
xtest = Xss(:,it1); indsgrid = zeros(T,1);
wpgrid=zeros(T,1);
tic
for it1 =1:T
    [xtss, errgg] = fsolve('ttce_ss', xtest, option0, parmf,parmU,parmT0(it1,:),...
                              talent, parmtt1,  indp(it1),qt(it1), dFA0) ;      
  
    xt22 = [xtss;parmtt1(:,:,2)'];
    zz = ttce_ssc(xt22,parmf,parmU,parmT0(it1,:),talent,parmtt1, ...
                          indp(it1) , qt(it1) ,dFA0 ,spp(it1) );                    
    [xtss2, errgg2] = fsolve('ttce_ssc', xt22, option0, parmf,parmU,parmT0(it1,:),...
                              talent, parmtt1,  indp(it1) , qt(it1) ,dFA0 ,spp(it1)) ;  
 
    Xtss(:,it1) = xtss2;       
    parmtt2 = cat(3,parmut, xtss2(end-1:end)');
    [test3, b] = ttce_ss(xtss2(1:end-2),parmf,parmU,parmT0(it1,:),talent,parmtt2,...
                  index_ss(it1),qt(it1) , dFA0) ;
    erg2(it1) = norm(errgg2,inf);
    parmtt1 =parmtt2;
 
    xtest =  xtss2(1:end-2);
    [indsgrid(it1), wpgrid(it1)] =s_indxss(xtest,parmf,parmU,talent,parmtt2, index_ss(it1));                      
 
end
 toc
 
 %%
optiont1 = optimset('Display','iter','MaxFunEvals',10^12,...
             'MaxIter',660,'TolFun',1e-6,'LargeScale','on');   
K00 = [Xtss(1,1);Xtss(3,1)];
 
ps1 = Xtss(end-1,:)'   ;  ps2 =    Xtss(end,:)' ;
phi = mean(Xtss(6:6+NN-1,:),2);  phi = phi/sum(phi.*PI);
parz = cat(3, zeros(T,2),   [ps1,ps2] );
 
xtest2 = [reshape(Xtss(1:5,:)', 5*T,1);ps1;ps2;phi];
moment = [index_s_data,spp]; 

 
% Set lsqnonlin upper and lower bound 
UBcet = 100*ones(length(xtest2),1); 
LBcet  = [zeros(5*T,1); -10*ones(2*T,1); zeros(NN,1)];                         

%%
tic
 [xce, erce] = lsqnonlin('ttce_transc', xtest2, LBcet,UBcet,optiont1,...
                                       parmf,parmU,parmT0,talent,parz , ...
                                       moment, qt , K00 );                                                              
toc  
     
 
[result,trd, alc40] = ttce_transc(xce,parmf,parmU,parmT0,talent,parz, ...
                              moment,  qt , K00 );

cdelta2 = Theta(2) -Theta(1);
threshold0 = trd;
indexe = floor(( trd- Theta(1))/cdelta2) +2;
su_ratio = 1-FPI(indexe-1);                     
pse = reshape(xce(5*T+1:7*T), T,2);                          
xce0 = [xce(1:5*T);xce(end-NN+1:end)];
parmtz = cat(3, zeros(T,2), pse);
phi0 = xce(end-NN+1:end);  
dfa0 = phi0/sum(PI.*phi0);
xsol40 = xce0;
 
test2 = ttce_trans(xsol40,parmf,parmU,parmT0,talent,parmtz,qt,K00,threshold0);
nxce= length(xce0);
 
ddff = xsol40;
dpaz = parmtz;
 
[result,trd, alc_ce] = ttce_trans(xsol40,parmf,parmU,parmT0,...
                                                talent,parmtz,qt,K00,threshold0);
 save CEext.mat
%load CEext.mat


function [xtss, parmtt ,index, dfA] = convert_CE(x,  parmU, pis, piu,zs,zu,ssk , talent)
% convert benchmark to  talent to task allocation (steady state)


parmpu =[0, log(zu)];
parmps = [0, log(zs)];
parmtt =  cat(3,parmpu,parmps);

Ks=x(1);
zNu=x(2);   % aggregate labor supply of unskilled labor
Ke=x(3);
zNs=x(4);   % aggregate labor supply of skilled labor
cs=x(5);      % skilled worker's consumption share
cu =x(6);    % unskilled worker's consumption share
C = pis*cs + piu*cu;
Pi = talent(:,2); N = length(Pi);
indx = (1:N)';
Sindx = indx( cumsum(Pi) >= piu+eps ); nsidx = length(Sindx);
Uindx = indx( cumsum(Pi) < 1-pis+eps) ;        nuidx = length(Uindx);
index = Sindx(1);


[~,ucs,~,~,~]  = util1([cs*ones(nsidx,1),zeros(nsidx,1)],parmU); phis =ucs.^(-1);
[~,ucu,~,~,~] = util1([cu*ones(nuidx,1),zeros(nuidx,1)],parmU); phiu = ucu.^(-1);
phi0 = [phiu ;phis] / ( sum(phis.*Pi(Sindx) )  +...
                                      sum(phiu.*Pi(Uindx)) );

xtss =[Ks;zNu;Ke;zNs;C;phi0];


dfA  =  [(1-pis*ssk)/piu*ones(nuidx,1); ...
               ssk*ones(nsidx,1)] ; % density of  asset holding at each type of workers
 
end
