%% Welfare Compare :  Skill premium, tax rates and social welfare improvement
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all; 
clear;clc 
lgdr = {'U.S','Ramsey' ,'Mirrlees'};
%%
% Load CE
load('CEext.mat')
index_I =(1:65)'; Year = 1962+index_I;
[result,trd, alc_ce] = ttce_trans(xsol40,parmf,parmU,parmT0,talent,parmtz,qt,K00,threshold0);

sp_ce = log(alc_ce.sp);
cecw = alc_ce.cweight;
Yce = alc_ce.Y;
Cce = alc_ce.C;
cce = alc_ce.c;
nce = alc_ce.n;

%% 
% Load Ramsey
load Ramsey_ext.mat
[xx,~,alcr, tax_r] =solve_Ramsy_tt(xrt2,parmf,parmU,parmp,parmtt,talent2, ...
                            iniK0, dfa1, qt ,trd_old);
 
sp_ramsey = log(alcr.sp) ;  
rcw = alcr.cweight;                        
Yr = alcr.Y;
Cr = alcr.C;
cr= alcr.c;
nr = alcr.n;
sw_r= swf(cr,nr,parmU,parmp,talent2);
sw_ce  = swf(cce,nce,parmU,parmp,talent);
%%
% Load Mirrlees
load Mirrlees_ext.mat                        
[testtt, trd_new2,alcsb2,taxsb] =Trans_ICtt3(xtsolsb2,parmfs,parmU,parmP22,...
                                                 talent_new,parmtt2,K0, qtt, trd_sb2, Delta_IC4,ctind);    
DT = T-TT;                                                                                  
sp_mirr = log(alcsb2.sp);
Ym = [alcsb.Y; alcsb2.Y(end)*ones(DT,1)];
Cm = [alcsb.C;alcsb2.C(end)*ones(DT,1)];
 
talentn = length(parmP22.weight);
cm= [alcsb.c   , alcsb.c(:,end).*ones(talentn,DT)];
nm = [alcsb.n  , alcsb.n(:,end).*ones(talentn,DT) ];
sw_m = swf(cm,nm,parmU,parmP22,talent_new);
 
%% Welfare analysis

% Decomposing welfare improvement on consumption and leisure;
% Level Effect
levelcr= Cr./Cce;
chat_r = levelcr'.*cce;

Nce = sum(nce.*talent(:,2),1)';
Nr = sum(nr.*talent(:,2),1)';
levelnr = Nr./Nce;
nhat_r = levelnr'.*nce;

sw_lcr =   swf(chat_r,nce,parmU,parmp,talent);
sw_lnr = swf(cce,nhat_r,parmU,parmp,talent);


CEVr =  ((sw_r.sw - sw_ce.l)/sw_ce.c).^(1/(1-gamma_c))-1;
CEVCr= (sw_r.c/sw_ce.c)^(1/(1-gamma_c)) -1;
CEVcr_level=  ( (sw_lcr.sw-sw_ce.l)/sw_ce.c).^(1/(1-gamma_c))-1;
CEVcr_dist =( (sw_r.c)/sw_lcr.c).^(1/(1-gamma_c))-1;

CEVLr=  ((sw_r.sw - sw_ce.l)/sw_r.c).^(1/(1-gamma_c))-1;
CEVlr_level = ((sw_lnr.sw-sw_ce.l)/sw_ce.c)^(1/(1-gamma_c))-1;
CEVlr_dist  =  ((sw_r.l + sw_ce.c -sw_lnr.l)/sw_ce.c)^(1/(1-gamma_c))-1;

%%
% Mirrlees
CEVm = ((sw_m.sw - sw_ce.l)/sw_ce.c).^(1/(1-gamma_c))-1;
 
Nm = sum(nm.*talent_new(:,2),1)';
levelcm = Cm./Cce;
levelnm = Nm./Nce;
chat_m = levelcm'.*cce;
nhat_m = levelnm'.*nce;
sw_lcm =   swf(chat_m,nce,parmU,parmp,talent);
sw_lnm = swf(cce,nhat_m,parmU,parmp,talent);

% Consumption
CEVCm =(sw_m.c/sw_ce.c)^(1/(1-gamma_c)) -1;
CEVcm_level=  ( (sw_lcm.sw-sw_ce.l)/sw_ce.c).^(1/(1-gamma_c))-1;
CEVcm_dist =( (sw_m.c)/sw_lcm.c).^(1/(1-gamma_c))-1;

 
CEVLm = ((sw_m.sw - sw_ce.l)/sw_m.c).^(1/(1-gamma_c))-1;
CEVlm_level=  ( (sw_lnm.l+sw_ce.c-sw_ce.l)/sw_ce.c).^(1/(1-gamma_c))-1;
CEVlm_dist  =  ((sw_m.l + sw_ce.c -sw_lnm.l)/sw_ce.c)^(1/(1-gamma_c))-1;
%%
clc
fprintf('\n \n \n \n \n')
disp('======= Table 3: Welfare gains and decomposition ======')
fprintf('                      Ramsey        Mirrlees  \n')
disp('_______________________________________________________')
fprintf('Total change          %3.2f            %3.2f \n',[CEVr  CEVm]*100)
fprintf('Consumption           %3.2f            %3.2f \n',[CEVCr  CEVCm]*100 )
fprintf('      Level:          %3.2f            %3.2f\n', [CEVcr_level CEVcm_level]*100 )               
fprintf('      Distribution:   %3.2f            %3.2f\n ',[CEVcr_dist  CEVcm_dist ]*100)
fprintf('Leisure             %3.2f           %3.2f \n',[CEVLr  CEVLm]*100 )
fprintf('      Level:         %3.2f           %3.2f\n', [CEVlr_level CEVlm_level]*100 )            
fprintf('      Distribution:   %3.2f           %3.2f\n ',[CEVlr_dist  CEVlm_dist ]*100)
disp('_______________________________________________________')


